Include "totalinvasion2_types.bmx"
Include "totalinvasion2_vector.bmx"
Include "totalinvasion2_objects.bmx"
Include "totalinvasion2_profiling.bmx"
Include "totalinvasion2_console.bmx"
Include "totalinvasion2_sectors.bmx"
Include "totalinvasion2_menu.bmx"

LoadSettings()

AppTitle = "TOTAL INVASION II"
SetGraphicsDriver GLGraphicsDriver()
GLShareContexts()
GLGraphics sResX[sWindowRes], sResY[sWindowRes], 0, 60
HideMouse()

GCSetMode 1
SeedRnd MilliSecs()

Global DEBUG:Byte = False

Const STATE_MENU:Byte = 0
Const STATE_GAME:Byte = 1
Const STATE_QUITTING:Byte = 3
Const STATE_CUTSCENE:Byte = 4
Const STATE_CREDITS:Byte = 5

Const DIFFICULTY_NORMAL:Byte = 0
Const DIFFICULTY_EASY:Byte = 1
Const DIFFICULTY_EASIEST:Byte = 2

Const MAX_PARTICLES = 128

Const ARMOR_NONE:Byte = 0
Const ARMOR_BORING:Byte = 1
Const ARMOR_BULLET:Byte = 2
Const ARMOR_SUPER:Byte = 3

Const DL_BLOCK:Byte = 0
Const DL_WALLS:Byte = 16
Const DL_FLOORS:Byte = 17

'Global i:Int = 0
'***
Global gGameState:Byte = STATE_MENU
Global gGameInitialized:Byte = False
Global gGameDifficulty:Byte = DIFFICULTY_NORMAL
Global gTime:Int = 0
Global gTime2:Int = 0
Global gLastTime:Long = 0
Global gDeltaTime:Long = 0
Global gTicks:Int = 0
Global gFps:Int = 0
Global gMouseDX:Int = 0

Global gCameraX:Float = 0.0
Global gCameraY:Float = 0.0
Global gCameraZ:Float = 0.0
Global gCameraYaw:Float = 0.0
Global gCameraShake:Float = 0.0
Global gCameraShakeTimer:Int = 0

Global gIdleTicks:Int = 0
Global gJokeIndex:Int = 0
Global gJokes:String[][] = [["WHAT'S THE MATTER?", "CAT GOT YOUR TONGUE?"], 
	["WHERE'S THE FEDERAL ARMY?", "WHAT A BUNCH OF SCAREDY-CATS!"],
	["THE WRAITHS RUINED MY GARDEN AGAIN...", "NOW THIS IS PURR-SONAL."],
	["IF ONLY THESE GUYS HAD BRAINS...", "THAT WOULD  BE CAT-ASTROPHIC!"],
	["THE BLOOD IS STAINING MY FUR", "YOU'VE GOTTA BE KITTY-NG ME!"],
	["THEY CREATED ME FOR WAR", "BUT IT STILL FREAKS MEOW-T SOMETIMES"],
	["WHAT IF THIS IS A SIMULATION...","IT'S PAWS-IBLE!"]]

Global gFlashR:Byte = 0
Global gFlashG:Byte = 0
Global gFlashB:Byte = 0
Global gFlashA:Float = 0.0

Global gMessage:String = ""
Global gMessageTimer:Int = 0
Global gMessageAlpha:Float = 1.0

Global gMouseLock:Int = True

Global gTextures:TMap = CreateMap()
Global gSounds:TMap = CreateMap()
Global gFont:Int[]

Const MAX_ENTITIES:Int = 1024
Global gEntities:TEntity[] = New TEntity[MAX_ENTITIES]
Global gMonsters:TList
Global gSecretWalls:TList = Null
Global gEnemyAIEnabled:Byte = True
Global gParticles:TParticle[MAX_PARTICLES]
Global gPlayer:TPlayer = Null
Global gGodMode:Byte = False

Global gMapWalls:TWall[] = Null
Global gMapWallGroups:TMap = CreateMap()

Global gMapFloors:TFloor[] = Null
Global gMapFloorGroups:TMap = CreateMap()
Global gMapNumber:Byte = 1
Global gEpisodeNumber:Byte = 1
Global gMapName:String = ""
Global gMapFlag:Byte = 0

Global gKillStat:Int = 0
Global gTimeStat:Int = 0
Global gSecretStat:Int = 0
Global gTotalSecrets:Int = 0
Global gTotalSecretWalls:Int = 0
Global gTotalMonsters:Int = 0

Global gMapIntroTimer:Byte = 0
Global gMapIntroAlpha:Float = 0.0

Global gDisplayLists:Int[] = Null

Global gCutsceneText:String[]
Global gCutsceneLine:Int = 0
Global gCutsceneIndex:Int = 0
Global gCutsceneDone:Int = False
Global gCutsceneTimer:Int = 0
Global gResetFlag:Byte = False
Global gCutScnFlag:Byte = False

Global gCreditsY:Float = 0.0
Global gTAnim:Int = 0
Global gTFrame:Int = 0

Const AMMO_EGG:Int = 1
Const AMMO_GRENADE:Int = 2
Const AMMO_PLASMA:Int = 3
Global gAmmoTypes:Int[] = New Int[4]

Global gMonsterChannels:TChannel[] = New TChannel[16]
For Local i:Int = 0 To 15
	gMonsterChannels[i] = AllocChannel()
Next
Global gAvailableMonsterChannel:Int = -1

Global gWeaponSickle:TWeapon = New TWeapon
gWeaponSickle.TextureName = "sickle_hud_"
gWeaponSickle.obituary = "GOT THE SICKLE!"
gWeaponSickle.ammoType = 0
gWeaponSickle.maxframes = 4
gWeaponSickle.equipped = True
gWeaponSickle.infiniteAmmo = True
Global gSicklePresent:Byte = False
Global gWeaponChicken:TWeapon = New TWeapon
gWeaponChicken.TextureName = "chickencannon_hud_"
gWeaponChicken.obituary = "GOT THE CHICKEN CANNON!"
gWeaponChicken.maxframes = 4
gWeaponChicken.maxcooldown = 10
gWeaponSickle.equipped = False
gWeaponChicken.ammoType = AMMO_EGG
gWeaponChicken.cameraShake = 5
Global gWeaponGrenade:TWeapon = New TWeapon
gWeaponGrenade.textureName = "grenadelauncher_hud_"
gWeaponGrenade.obituary = "GOT THE GRENADE LAUNCHER!"
gWeaponGrenade.equipped = False
gWeaponGrenade.maxframes = 4
gWeaponGrenade.knockback = 0.5
gWeaponGrenade.ammoType = AMMO_GRENADE
gWeaponGrenade.cameraShake = 10
Global gWeaponDoubleGrenade:TWeapon = New TWeapon
gWeaponDoubleGrenade.textureName = "doublegrenadelauncher_hud_"
gWeaponDoubleGrenade.obituary = "OOH! DOUBLE GRENADE LAUNCHER!"
gWeaponDoubleGrenade.equipped = False
gWeaponDoubleGrenade.ammoType = AMMO_GRENADE
gWeaponDoubleGrenade.maxframes = 5
gWeaponDoubleGrenade.knockback = 16.0
gWeaponDoubleGrenade.cameraShake = 20
Global gWeaponParusu:TWeapon = New TWeapon
gWeaponParusu.TextureName = "parusu_hud_"
gWeaponParusu.obituary = "GOT THE PARUSU!"
gWeaponParusu.equipped = False
gWeaponParusu.ammoType = AMMO_PLASMA
gWeaponParusu.maxframes = 4
gWeaponParusu.maxcooldown = 5
gWeaponParusu.knockback = 0.0
Global gWeaponSign:TWeapon = New TWeapon
gWeaponSign.TextureName = "signofmadness_hud_"
gWeaponSign.obituary = "GOT THE SIGN OF MADNESS!"
gWeaponSign.equipped = False
gWeaponSign.ammoType = 0
gWeaponSign.infiniteAmmo = True
gWeaponSign.maxframes = 5
gWeaponSign.maxcooldown = 50
Global gWeaponAirhorn:TWeapon = New TWeapon
gWeaponAirhorn.TextureName = "airhorn_hud_"
gWeaponAirhorn.obituary = "GET REKT, M8!"
gWeaponAirhorn.equipped = False
gWeaponAirhorn.ammoType = 0
gWeaponAirhorn.infiniteAmmo = True
gWeaponAirhorn.maxframes = 4
gWeaponAirhorn.maxcooldown = 10

Global gKeycards:Int[]

Global gWeapon:TWeapon = gWeaponSickle
Global gWeaponOffsetY:Float = 0.0
Global gWeaponOffsetX:Float = 0.0
Global gWeaponBob:Float = 0.0
Global gWeaponChange:Int = 0
Global gNewWeapon:TWeapon = Null

gFont = New Int[128]
Local pixmap:TPixmap = LoadPixmap("assets/textures2/font.png")
For Local i = 0 To Len(gFont) - 1
	Local p:TPixmap = pixmap.Window((i*16) Mod 128, Floor((i*16)/128)*16, 16, 16)
	gFont[i] = LoadTextureFromPixmap(p)
Next
Print "FONT LOADED!"

glMatrixMode(GL_PROJECTION)
glLoadIdentity()
glOrtho(0.0, 320, 240, 0.0, -1.0, 10.0)
glMatrixMode(GL_MODELVIEW)
glLoadIdentity()
glEnable GL_BLEND
glEnable GL_TEXTURE_2D

glClear GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT
DrawString("LOADING...", gFont, 4, 4, 16)
Flip

'=============
'*LOAD
'=============

Global gVictoryMusic:TSound = LoadSound("assets/music/viktorthechampion.ogg", SOUND_LOOP)
Global gBossMusic:TSound = LoadSound("assets/music/eyeofprovidence.ogg", SOUND_LOOP)
Global gInterludeMusic:TSound = LoadSound("assets/music/interlude.ogg", SOUND_LOOP)
Global gFinalBossMusic:TSound = LoadSound("assets/music/towinthegameyouhavetokillme.ogg", SOUND_LOOP)
Global gCreditsMusic:TSound = LoadSound("assets/music/shaft.ogg", SOUND_LOOP)
Global gTitleMusic:TSound = LoadSound("assets/music/nekonightmare.ogg", SOUND_LOOP)

ChangeDir "assets/textures/"
Local dir:Byte Ptr = ReadDir(CurrentDir())
Local tex:Int = 0
Local texture:TTexture = Null
Local nf:String = ""
Repeat
	nf = NextFile(dir)
	If nf = "." Or nf = ".." Then Continue
	If nf = "" Then Exit
	If LoadPixmap(nf) <> Null Then
		tex = LoadTexture(nf)
		texture = New TTexture
		texture.id = tex
		texture.name = StripAll(nf)
		MapInsert gTextures, StripAll(nf), texture
		Print "TEXTURE LOADED: " + StripAll(nf)
	EndIf
Forever
CloseDir dir
ChangeDir "../sounds/"
dir = ReadDir(CurrentDir())
nf = ""
Repeat
	nf = NextFile(dir)
	If nf = "." Or nf = ".." Then Continue
	If nf = "" Then Exit
	If Instr(StripAll(nf), "_looped") > 0 Then
		MapInsert gSounds, StripAll(nf), LoadSound(nf, SOUND_LOOP)
		Print "LOOPED SOUND LOADED: " + StripAll(nf)
	Else
		MapInsert gSounds, StripAll(nf), LoadSound(nf)
		Print "SOUND LOADED: " + StripAll(nf)
	EndIf
Forever
CloseDir dir
ChangeDir "../.."

LoadTexture2("assets/textures2/stock.png", "stock_0")
LoadTexture2("assets/textures2/hud.png", "hud")
LoadTexture2("assets/textures2/egg.png", "egg")
LoadTexture2("assets/textures2/FUNDIEHAND.png", "FUNDIEHAND_0")
LoadTexture2("assets/textures2/titlecursor.png", "titlecursor")
LoadTexture2("assets/textures2/title.png", "title")
LoadTexture2("assets/textures2/titlegraphic.png", "titlegraphic")
LoadTexture2("assets/textures2/bluecard_hud.png", "bluecard_hud")
LoadTexture2("assets/textures2/browncard_hud.png", "browncard_hud")
LoadTexture2("assets/textures2/yellowcard_hud.png", "yellowcard_hud")
LoadTexture2("assets/textures2/graycard_hud.png", "graycard_hud")
LoadTexture2("assets/textures2/levelintro.png", "levelintro")
LoadAnimTexture("assets/textures2/SEGAN_VICTORY.png", 64, 64)
LoadAnimTexture("assets/textures2/sickle_hud.png", 256, 256)
LoadAnimTexture("assets/textures2/chickencannon_hud.png", 256, 256)
LoadAnimTexture("assets/textures2/grenadelauncher_hud.png", 256, 256)
LoadAnimTexture("assets/textures2/doublegrenadelauncher_hud.png", 256, 256)
LoadAnimTexture("assets/textures2/airhorn_hud.png", 256, 256)
LoadAnimTexture("assets/textures2/parusu_hud.png", 256, 256)
LoadAnimTexture("assets/textures2/signofmadness_hud.png", 512, 512)
LoadAnimTexture("assets/textures2/sickle.png", 32, 32)
LoadAnimTexture("assets/textures2/WRAITH0.png", 64, 64)
LoadAnimTexture("assets/textures2/WRAITH1.png", 64, 64)
LoadAnimTexture("assets/textures2/WRAITH2.png", 64, 64)
LoadAnimTexture("assets/textures2/FIREWRAITH0.png", 64, 64)
LoadAnimTexture("assets/textures2/FIREWRAITH1.png", 64, 64)
LoadAnimTexture("assets/textures2/FIREWRAITH2.png", 64, 64)
LoadAnimTexture("assets/textures2/CHICKEN0.png", 64, 64)
LoadAnimTexture("assets/textures2/CHICKEN1.png", 64, 64)
LoadAnimTexture("assets/textures2/CHICKEN2.png", 64, 64)
LoadAnimTexture("assets/textures2/DUMMKOPF0.png", 64, 64)
LoadAnimTexture("assets/textures2/DUMMKOPF1.png", 64, 64)
LoadAnimTexture("assets/textures2/DUMMKOPF2.png", 64, 64)
LoadAnimTexture("assets/textures2/PAWN0.png", 64, 64)
LoadAnimTexture("assets/textures2/CACOWRAITH0.png", 64, 64)
LoadAnimTexture("assets/textures2/CACOWRAITH1.png", 64, 64)
LoadAnimTexture("assets/textures2/CACOWRAITH2.png", 64, 64)
LoadAnimTexture("assets/textures2/PRISRAK0.png", 64, 64)
LoadAnimTexture("assets/textures2/PRISRAK1.png", 64, 64)
LoadAnimTexture("assets/textures2/PRISRAK2.png", 64, 64)
LoadAnimTexture("assets/textures2/PROVIDENCE0.png", 128, 128)
LoadAnimTexture("assets/textures2/PROVIDENCE1.png", 128, 128)
LoadAnimTexture("assets/textures2/PROVIDENCE2.png", 128, 128)
LoadAnimTexture("assets/textures2/FUNDIE0.png", 64, 64)
LoadAnimTexture("assets/textures2/FUNDIE1.png", 64, 64)
LoadAnimTexture("assets/textures2/FUNDIE2.png", 64, 64)
LoadAnimTexture("assets/textures2/BANSHEE0.png", 64, 64)
LoadAnimTexture("assets/textures2/BANSHEE1.png", 64, 64)
LoadAnimTexture("assets/textures2/BANSHEE2.png", 64, 64)
LoadAnimTexture("assets/textures2/MUTANT0.png", 64, 64)
LoadAnimTexture("assets/textures2/MUTANT1.png", 64, 64)
LoadAnimTexture("assets/textures2/MUTANT2.png", 64, 64)
LoadAnimTexture("assets/textures2/MECHA0.png", 64, 64)
LoadAnimTexture("assets/textures2/MECHA1.png", 64, 64)
LoadAnimTexture("assets/textures2/MECHA2.png", 64, 64)
LoadAnimTexture("assets/textures2/DEMON0.png", 512, 512)
LoadAnimTexture("assets/textures2/GOD0.png", 64, 64)
LoadAnimTexture("assets/textures2/FIREBALL.png", 64, 64)
LoadAnimTexture("assets/textures2/PLASMABALL.png", 64, 64)
LoadAnimTexture("assets/textures2/CACOBALL.png", 64, 64)
LoadAnimTexture("assets/textures2/particles.png", 8, 8)
LoadAnimTexture("assets/textures2/grenade.png", 64, 64)
LoadAnimTexture("assets/textures2/missile0.png", 64, 64)
LoadAnimTexture("assets/textures2/missile1.png", 64, 64)
LoadAnimTexture("assets/textures2/missile2.png", 64, 64)
LoadAnimTexture("assets/textures2/explosion.png", 64, 64)
LoadAnimTexture("assets/textures2/CTRLWRAITH.png", 64, 64)
LoadAnimTexture("assets/textures2/SEGAN_EXIT.png", 64, 64)
LoadAnimTexture("assets/textures2/SEGAN0.png", 64, 64)

Global gMusic:TSound = Null
Global gMusicChannel:TChannel = Null

Global gRenderTarget:Int = 0
glGenTextures 1, Varptr gRenderTarget
glBindTexture GL_TEXTURE_2D, gRenderTarget
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST)
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST)
glBindTexture GL_TEXTURE_2D, Null

Global gKeyString:String = ""
SetGraphicsDriver GLGraphicsDriver()

BuildLists()

OnEnd Cleanup

gMusicChannel = PlaySound(gTitleMusic)

'Make3D()
'===========
'_LOOP
'===========

Const TICKSPEED:Int = ((1.000/65.000)*1000.000) 

gLastTime = MilliSecs()
gDeltaTime = 0
While Not AppTerminate()
	Local now = MilliSecs()
	gDeltaTime = MilliSecs() - gLastTime
	gLastTime = now
	gTime2 :+ gDeltaTime
	If gTime2 > TICKSPEED Then
		Tick()
		gTime2 = 0
	EndIf
Wend

Function Tick()
	'16.66666666 millisecs in a frame for 60fps
	glViewport 0.0, 0.0,sResX[sGameRes], sResY[sGameRes]
	'If gEpisodeNumber = 3 And gGameState = STATE_GAME Then glClearColor 0.6, 0.6, 0.16, 1.0 Else glClearColor 0.0, 0.0, 0.0, 1.0
	
	glClear GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT
		Select gGameState
		Case STATE_MENU
			UpdateMenu()
		Case STATE_QUITTING
				Begin2D()
				
				glColor3f 1.0, 0.0, 1.0
				DrawString("YOU SURE YOU WANT TO QUIT? (Y/N)", gFont, 4, 4, 8)
				
				gTAnim :+ 1
				If gTAnim > 3 Then
					gTAnim = 0
					gTFrame :+ 1
					If gTFrame > 7 Then gTFrame = 0
				EndIf
				glColor4f 1.0, 1.0, 1.0, 1.0
				glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, "SEGAN_EXIT_" + gTFrame)).id
				glBegin GL_QUADS
					glTexCoord2f 0.0, 1.0; glVertex2f 128.0, 152.0
					glTexCoord2f 1.0, 1.0; glVertex2f 192.0, 152.0
					glTexCoord2f 1.0, 0.0; glVertex2f 192.0, 88.0
					glTexCoord2f 0.0, 0.0; glVertex2f 128.0, 88.0
				glEnd
				glBindTexture GL_TEXTURE_2D, Null
		
				End2D()
				FitToScreen()
				
				If KeyHit(KEY_Y) Or InputPressed(KEY_CONFIRM) Then End
				If KeyHit(KEY_N) Or InputPressed(KEY_EXIT) Then 
					gGameState = STATE_MENU
					gTAnim = 0
					gTFrame = 0
					FlushKeys()
					FlushMouse()
				EndIf
		Case STATE_CREDITS
			gCreditsY :+ 0.2
			If InputDown(KEY_CONFIRM) Then
				gCreditsY :+ 0.2
			EndIf
			gTAnim :+ 1
			If gTAnim > 10 Then
				gTAnim = 0
				gTFrame :+ 1
				If gTFrame > 3 Then
					gTFrame = 0
				EndIf
			EndIf
			Begin2D()
			glTranslatef 0.0, -gCreditsY, 0.0
			glColor4f 1.0, 1.0, 1.0, 1.0
			DrawString("CREDITS:", gFont, 4, 244)
			DrawString("PROGRAMMING:THE TOPHAT DEMON", gFont, 4, 252, 8)
			DrawString("ART:THE TOPHAT DEMON", gFont, 4, 260, 8)
			DrawString("MUSIC:THE TOPHAT DEMON", gFont, 4, 268, 8)
			DrawString("LEVEL DESIGN:THE TOPHAT DEMON", gFont, 4, 276, 8)
			DrawString("SOUND EFFECTS CREDITS ARE INCLUDED IN:", gFont, 4, 292, 8)
			DrawString("SOUND CREDITS.TXT", gFont, 4, 300, 8)
			DrawString("SPECIAL THANKS: ", gFont, 4, 316, 16)
			DrawString("MR./B/, WHO IS ALWAYS WATCHING.", gFont, 4, 332, 8)
			DrawString("CALEB HUGHES, THE PLAYTESTER", gFont, 4, 340, 8)
			DrawString("MR./V/, FOR SEGAN'S NAME.", gFont, 4, 348, 8)
			DrawString("MR.SKELTAL, FOR GIVING MY BONES CALCIUM.", gFont, 4, 356, 8)
			DrawString("ID SOFTWARE", gFont, 4, 364, 8)
			DrawString("MARKUS PERSSON", gFont, 4, 372, 8)
			DrawString("OP'S MOM", gFont, 4, 380, 8)
			DrawString("KEN SILVERMAN", gFont, 4, 388, 8)
			DrawString("THAT MUSTARD STAIN ON THE CARPET", gFont, 4, 396, 8)
			DrawString("A TRASH CAN", gFont, 4, 404, 8)
			DrawString("GALAXYTRAIL GAMES", gFont, 4, 412, 8)
			
			DrawString("WRAITH", gFont, 4, 500, 8)
			DrawSpinningMonster(160, 484, gTFrame, "WRAITH")
			DrawString("FIRE WRAITH", gFont, 4, 572, 8)
			DrawSpinningMonster(160, 556, gTFrame, "FIREWRAITH")
			DrawString("DUMMKOPF", gFont, 4, 644, 8)
			DrawSpinningMonster(160, 628, gTFrame, "DUMMKOPF")
			DrawString("CACOWRAITH", gFont, 4, 716, 8)
			DrawSpinningMonster(160, 700, gTFrame, "CACOWRAITH")
			DrawString("PRISRAK", gFont, 4, 788, 8)
			DrawSpinningMonster(160, 772, gTFrame, "PRISRAK")
			DrawString("PROVIDENCE", gFont, 4, 860, 8)
			DrawSpinningMonster(224, 844, gTFrame, "PROVIDENCE", 64.0)
			DrawString("HUH?", gFont, 4, 996, 8)
			DrawSpinningMonster(160, 980, gTFrame, "FUNDIE")
			DrawString("BANSHEE", gFont, 4, 1068, 8)
			DrawSpinningMonster(160, 1052, gTFrame, "BANSHEE")
			DrawString("MUTANT WRAITH", gFont, 4, 1140, 8)
			DrawSpinningMonster(160, 1124, gTFrame, "MUTANT")
			DrawString("MECHA WRAITH", gFont, 4, 1212, 8)
			DrawSpinningMonster(160, 1196, gTFrame, "MECHA")
			DrawString("THE TOPHAT DEMON", gFont, 4, 1284, 8)
			DrawSpinningMonster(224, 1308, 0, "DEMON", 64.0)
			DrawString("THE TOPHAT DEMON", gFont, 4, 1420, 8)
			DrawSpinningMonster(160, 1404, 0, "GOD")
			DrawString("SEGAN", gFont, 4, 1492, 8)
			DrawSpinningMonster(160, 1476, 0, "SEGAN")
			
			DrawString("THANKS FOR PLAYING", gFont, 4, 1640, 8)
			
			End2D()
			glLoadIdentity()
			FitToScreen()
			If InputPressed(KEY_EXIT) Then
				End
			EndIf
		Case STATE_CUTSCENE
			SetChannelVolume gMusicChannel, sMusicVolume
			If Not gCutsceneDone Then
				gCutsceneTimer :+ 1
				If gCutsceneTimer > 1 Then
					gCutsceneTimer = 0
					gCutsceneIndex :+ 1
					If gCutsceneIndex > Len(gCutsceneText[gCutsceneLine]) - 1 Then
						gCutsceneIndex = 0
						gCutsceneLine :+ 1
						If gCutsceneLine > Len(gCutsceneText) - 1 Then
							gCutsceneLine = Len(gCutsceneText) - 1
							gCutsceneDone = True
						EndIf
					EndIf
				EndIf
			EndIf
			
			Begin2D()
			glColor4f 0.5, 1.0, 0.0, 1.0
			For Local i:Int = 0 To gCutsceneLine - 1
				DrawString(gCutsceneText[i], gFont, 4, 4 + (i * 10), 6)
			Next	
			If gCutsceneDone = False Then
				DrawString(Mid(gCutsceneText[gCutsceneLine], 0, gCutsceneIndex), gFont, 4, 4 + (gCutsceneLine * 10), 6)
			Else
				DrawString(gCutsceneText[gCutsceneLine], gFont, 4, 4 + (gCutsceneLine * 10), 6)
			EndIf
			glColor4f 1.0, 0.5, 0.0, 1.0
			DrawString("PRESS ENTER TO CONTINUE", gFont, 4, 228, 8)
			End2D()
			FitToScreen()
			If InputPressed(KEY_CONFIRM) Then 
				If gMapNumber = 9 Then
					gGameState = STATE_MENU
					gGameInitialized = False
					StopChannel gMusicChannel
					If gEpisodeNumber = 3 Then
						gGameState = STATE_CREDITS
						gMusicChannel = PlaySound(gCreditsMusic)
						SetChannelVolume gMusicChannel, sMusicVolume
					EndIf
					GCCollect()				
				Else
					gGameState = STATE_GAME
					Make3D()
					StopChannel gMusicChannel
					If gMusic <> Null Then gMusicChannel = PlaySound(gMusic)
					GCCollect()
					gGameInitialized = True
					gCutScnFlag = False
					gCutsceneIndex = 0
					gCutsceneLine = 0
					gCutsceneDone = False
				EndIf
			EndIf
		Case STATE_GAME
			'======================================
			'*GAMESTATE
			'======================================
			
			SetChannelVolume gMusicChannel, sMusicVolume
			
			gAvailableMonsterChannel = -1
			For Local i:Int = 0 To 15
				If Not ChannelPlaying(gMonsterChannels[i]) And gAvailableMonsterChannel = -1 Then
					gAvailableMonsterChannel = i
				EndIf
				SetChannelVolume gMonsterChannels[i], sSoundVolume
			Next
			
			glMatrixMode(GL_MODELVIEW)
			glLoadIdentity
			glRotatef gCameraYaw, 0, 1, 0
			glRotatef gCameraShake, 0, 0, 1
			glTranslatef gCameraX, gCameraY, gCameraZ
			gCameraX = -gPlayer.x
			gCameraY = -gPlayer.y
			gCameraZ = -gPlayer.z
			gCameraYaw = gPlayer.yaw
			If gPlayer.state = 2 Then
				gCameraX = -(gPlayer.x - Cos(gPlayer.yaw - 90.0) * 4.0)
				gCameraZ = -(gPlayer.z - Sin(gPlayer.yaw - 90.0) * 4.0)
			EndIf
			If gCameraShakeTimer > 0 Then
				gCameraShakeTimer :- 1
				gCameraShake = Rnd(-1.0, 1.0)
			Else
				gCameraShake = 0.0
			EndIf
			If gFlashA > 0.0 Then gFlashA = Max(gFlashA - 0.05, 0.0)
			If gMessageTimer > 0 Then gMessageTimer = Max(gMessageTimer - 1, 0.0)
			If gMessageTimer < 10 Then 
				gMessageAlpha = Max(gMessageAlpha - 0.1, 0.0)
			Else
				gMessageAlpha = 1.0
			EndIf
			If gMessageTimer = 0 Then
				gMessage = ""
				gMessageAlpha = 1.0
			EndIf
			
			If gAmmoTypes[AMMO_GRENADE] > 100 Then gAmmoTypes[AMMO_GRENADE] = 100
			If gAmmoTypes[AMMO_EGG] > 256 Then gAmmoTypes[AMMO_EGG] = 256
			If gAmmoTypes[AMMO_PLASMA] > 500 Then gAmmoTypes[AMMO_PLASMA] = 500
			For Local i:Int = 0 To 3
				If gAmmoTypes[i] < 0 Then gAmmoTypes[i] = 0
			Next
			
			If InputPressed(KEY_SELECT_SICKLE) Then
				gNewWeapon = gWeaponSickle
				gNewWeapon.frame = 0
				gWeaponChange = 1
				gWeaponOffsetY = 0
				gWeaponBob = 0
				gPlayer.canShoot = True
			ElseIf InputPressed(KEY_SELECT_CHICKENCANNON) And gWeaponChicken.equipped Then
				gNewWeapon = gWeaponChicken
				gNewWeapon.frame = 0
				gWeaponChange = 1
				gWeaponOffsetY = 0
				gWeaponBob = 0
				gPlayer.canShoot = True
			ElseIf InputPressed(KEY_SELECT_GRENADELAUNCHER) And gWeaponGrenade.equipped Then
				gNewWeapon = gWeaponGrenade
				gNewWeapon.frame = 0
				gWeaponChange = 1
				gWeaponOffsetY = 0
				gWeaponBob = 0
				gPlayer.canShoot = True
			ElseIf InputPressed(KEY_SELECT_PARUSU) And gWeaponParusu.equipped Then
				gNewWeapon = gWeaponParusu
				gNewWeapon.frame = 0
				gWeaponChange = 1
				gWeaponOffsetY = 0
				gWeaponBob = 0
				gPlayer.canShoot = True
			ElseIf InputPressed(KEY_SELECT_DOUBLEGRENADELAUNCHER) And gWeaponDoubleGrenade.equipped Then
				gNewWeapon = gWeaponDoubleGrenade
				gNewWeapon.frame = 0
				gWeaponChange = 1
				gWeaponOffsetY = 0
				gWeaponBob = 0
				gPlayer.canShoot = True
			ElseIf InputPressed(KEY_SELECT_SIGNOFMADNESS) And gWeaponSign.equipped Then
				gNewWeapon = gWeaponSign
				gNewWeapon.frame = 0
				gWeaponChange = 1
				gWeaponOffsetY = 0
				gWeaponBob = 0
				gPlayer.canShoot = True
			ElseIf InputPressed(KEY_SELECT_AIRHORN) And gWeaponAirhorn.equipped Then
				gNewWeapon = gWeaponAirhorn
				gNewWeapon.frame = 0
				gWeaponChange = 1
				gWeaponOffsetY = 0
				gWeaponBob = 0
				gPlayer.canShoot = True
			EndIf
			
			If gWeaponChange > 0 Then
				gWeaponChange :+ 1
				If gWeaponChange < 15 Then
					gWeaponOffsetY :+ 16.0
				ElseIf gWeaponChange = 15 Then
					gWeapon = gNewWeapon
				ElseIf gWeaponChange > 15 Then
					gWeaponOffsetY :- 16.0
				EndIf
				If gWeaponChange = 30 Then
					gWeaponChange = 0
				EndIf
			EndIf		
			If gMapIntroTimer > 125 Then gPlayer.Update()
			
			ProfileStart("WALL RENDER")
			For Local walg:TTextureChain = EachIn MapValues(gMapWallGroups)
				walg.Render()
			Next
			ProfileEnd("WALL RENDER")
			
			ProfileStart("FLOORS")			
			glColor3f 1.0, 1.0, 1.0
			For Local flrg:TTextureChain = EachIn MapValues(gMapFloorGroups)
				flrg.Render()
			Next
			ProfileEnd("FLOORS")
			
			ProfileStart("ENTITIES")
			glColor3f 1.0, 1.0, 1.0
			For Local e:TEntity = EachIn gEntities
				e.Update()
				e.Render()
			Next
			ProfileEnd("ENTITIES")
			
			ProfileStart("MONSTERS")
			For Local m:TMonster = EachIn gMonsters
				m.Update()
				m.Render()
			Next
			ProfileEnd("MONSTERS")
			
			ProfileStart("PARTICLES")
			RenderParticles()
			ProfileEnd("PARTICLES")
			
			'==========
			'*HUD
			'==========
			ProfileStart("HUD")
			Begin2D()
			glColor3f 1.0, 1.0, 1.0
			
			If gPlayer.state <> 2 Then
				If gWeaponChange = 0 Then
					gWeaponOffsetX = Floor(Cos(gWeaponBob*5)*4)
					gWeaponOffsetY = Floor(Sin(gWeaponBob*10)*6)
				Else
					gWeaponOffsetX = 0
				EndIf
				glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, gWeapon.TextureName + gWeapon.frame)).id
				If gWeapon = gWeaponSickle Then gWeaponOffsetX :+ 95
				If gWeapon = gWeaponAirhorn Then gWeaponOffsetX :+ 80
				If gWeapon = gWeaponSign Then
					gWeaponOffsetX :- 128
					'gWeaponOffsetY :- 128
					glBegin GL_QUADS
						glTexCoord2f 0.0, 1.0; glVertex2f 75 + gWeaponOffsetX        , 514 + gWeaponOffsetY
						glTexCoord2f 1.0, 1.0; glVertex2f 587 + gWeaponOffsetX       , 514 + gWeaponOffsetY
						glTexCoord2f 1.0, 0.0; glVertex2f 587 + gWeaponOffsetX       , 2 + gWeaponOffsetY
						glTexCoord2f 0.0, 0.0; glVertex2f 75 + gWeaponOffsetX        , 2 + gWeaponOffsetY
					glEnd
				Else
					glBegin GL_QUADS
						glTexCoord2f 0.0, 1.0; glVertex2f 75 + gWeaponOffsetX        , 342 + gWeaponOffsetY
						glTexCoord2f 1.0, 1.0; glVertex2f 331 + gWeaponOffsetX       , 342 + gWeaponOffsetY
						glTexCoord2f 1.0, 0.0; glVertex2f 331 + gWeaponOffsetX       , 86 + gWeaponOffsetY
						glTexCoord2f 0.0, 0.0; glVertex2f 75 + gWeaponOffsetX        , 86 + gWeaponOffsetY
					glEnd
				EndIf
			Else
				DrawString("LEVEL COMPLETE!", gFont, 40, 32, 16)
				DrawString("KILLS: " + gKillStat, gFont, 4, 64, 8)
				DrawString("SECRETS: " + gSecretStat+"/"+gTotalSecrets, gFont, 4, 80, 8)
				DrawString("TIME: " + Int(Floor(gTimeStat/60)) + "M" + Int(gTimeStat Mod 60) + "S", gFont, 4, 96, 8)
			EndIf
			glBindTexture GL_TEXTURE_2D, Null
			If gFlashA > 0.0 Then
				glBegin GL_QUADS
				glColor4f gFlashR/255, gFlashG/255, gFlashB/255, gFlashA
				glVertex2f 0.0, 240.0
				glVertex2f 320.0, 240.0
				glVertex2f 320.0, 0.0
				glVertex2f 0.0, 0.0
				glColor4f 1.0, 1.0, 1.0, 1.0
				glEnd
			EndIf
			glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, "hud")).id
			glBegin GL_QUADS 
				glTexCoord2f 0.0, 1.0; glVertex2f 32  , 240 
				glTexCoord2f 1.0, 1.0; glVertex2f 288, 240 
				glTexCoord2f 1.0, 0.0; glVertex2f 288, -16
				glTexCoord2f 0.0, 0.0; glVertex2f 32  , -16
			glEnd
			glColor4f 1.0, 0.0, 0.0, 1.0
			DrawString("HP:"+gPlayer.health, gFont, 36, 228, 8)
			glColor4f 0.0, 0.2, 1.0, 1.0
			DrawString("AMMO:"+gAmmoTypes[gWeapon.ammoType], gFont, 84, 228, 8)
			glColor4f 1.0, 0.5, 0.0, 1.0
			DrawString("ARMOR:"+gPlayer.armor, gFont, 188, 228, 8)
			If gMessageTimer > 0 Then
				glColor4f 1.0, 0.0, 0.0, gMessageAlpha
				DrawString(gMessage, gFont, 160-((Len(gMessage)*8)/2), 112)
			EndIf
			glColor4f 1.0, 1.0, 1.0, 1.0
			If gPlayer.armorType <> ARMOR_NONE Then
				Select gPlayer.armorType
					Case ARMOR_BORING
						DrawString("-BORING ARMOR-", gFont, 104, 4, 8)
					Case ARMOR_BULLET
						DrawString("-BULLET ARMOR-", gFont, 104, 4, 8)
					Case ARMOR_SUPER
						DrawString("-SUPER ARMOR-", gFont, 108, 4, 8)
				EndSelect
			EndIf
			For Local i:Int = 0 To 3
				If gKeycards[i] = True Then
					Select i
						Case 0
							glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, "bluecard_hud")).id
						Case 1
							glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, "browncard_hud")).id
						Case 2
							glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, "yellowcard_hud")).id
						Case 3
							glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, "graycard_hud")).id
					End Select
					'x = 149
					'y = 228
					glBegin GL_QUADS
						glTexCoord2f 0.0, 1.0; glVertex2f 149.0+(i*10.0)    , 228.0+8.0
						glTexCoord2f 1.0, 1.0; glVertex2f 149.0+(i*10.0)+8.0, 228.0+8.0
						glTexCoord2f 1.0, 0.0; glVertex2f 149.0+(i*10.0)+8.0, 228.0
						glTexCoord2f 0.0, 0.0; glVertex2f 149.0+(i*10.0)    , 228.0
					glEnd
				EndIf
			Next
			DrawString("FPS: " + gFps, gFont, 4, 4)
			'DrawString("X: " + gPlayer.x, gFont, 4, 20)
			'DrawString("Z: " + gPlayer.z, gFont, 4, 36)
			If DEBUG Then
				glColor3f 1.0, 1.0, 1.0
				DrawSector(gSectors[0].parent)
				glColor3f 1.0, 0.0, 1.0
				glBegin GL_QUADS
					glVertex2f gPlayer.x-1+128, gPlayer.z-1+32
					glVertex2f gPlayer.x-1+128, gPlayer.z+1+32
					glVertex2f gPlayer.x+1+128, gPlayer.z+1+32
					glVertex2f gPlayer.x+1+128, gPlayer.z-1+32
				glEnd
				For Local m:TMonster = EachIn gMonsters
					If m.class = "monster" Then
						glColor3f 1.0, 0.0, 0.0
						glBegin GL_QUADS
							glVertex2f m.x-1+128, m.z-1+32
							glVertex2f m.x-1+128, m.z+1+32
							glVertex2f m.x+1+128, m.z+1+32
							glVertex2f m.x+1+128, m.z-1+32
						glEnd
					EndIf
				Next
			EndIf
			If DEBUG Then gMapIntroTimer = 200
			If gMapIntroTimer < 150 Then
				gMapIntroTimer :+ 1
				If gMapIntroTimer > 125 Then gMapIntroAlpha :- 0.04
				glBegin GL_QUADS
					glColor4f 0.0, 0.0, 0.0, gMapIntroAlpha
					glVertex2f 0.0, 240.0 
					glVertex2f 320.0, 240.0 
					glVertex2f 320.0, 0.0
					glVertex2f 0.0, 0.0
				glEnd
				glColor4f 1.0, 1.0, 1.0, 1.0
				glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, "levelintro")).id
				glBegin GL_QUADS
					'96, 56, 224, 184
					glVertex2f 96.0, 56.0 - 8; glTexCoord2f 0.0, 1.0
					glVertex2f 96.0, 184.0 - 8; glTexCoord2f 1.0, 1.0
					glVertex2f 224.0, 184.0 - 8; glTexCoord2f 1.0, 0.0
					glVertex2f 224.0, 56.0 - 8; glTexCoord2f 0.0, 0.0
				glEnd
				glBindTexture GL_TEXTURE_2D, Null
				DrawString("E"+gEpisodeNumber+"M"+gMapNumber, gFont, 128, Max(240 - gMapIntroTimer*6, 88), 16)
				DrawString(gMapName, gFont, 160-(Len(gMapName)*4), Max(480 - gMapIntroTimer*6, 112), 8)
			EndIf
			
			ProfileEnd("HUD")
			ProfileRender()
			
			End2D()
			FitToScreen()
						
			If gResetFlag = True Then
				gGameState = STATE_GAME
				ResetGame()
				InitGame()
				gResetFlag = False
			EndIf
			If gCutScnFlag = True Then
				gCutScnFlag = False
				gCutsceneIndex = 0
				gCutsceneLine = 0
				gCutsceneDone = False
				gGameState = STATE_CUTSCENE
				'gGameInitialized = False
				'gTitleIndex = 1
				StopChannel gMusicChannel
				gMusicChannel = PlaySound(gInterludeMusic)
				If gEntities <> Null Then
					For Local ee:TEntity = EachIn gEntities
						If TSickle(ee) <> Null Then 
							StopChannel(TSickle(ee).sound)
						EndIf
						If ee <> Null Then RemoveEntity(ee)
					Next
				EndIf
				gEntities = New TEntity[MAX_ENTITIES]
				gParticles = New TParticle[MAX_PARTICLES]
				For Local i:Int = 0 To MAX_PARTICLES - 1
					gParticles[i] = New TParticle
					gParticles[i].active = False
				Next

				GCCollect()
			EndIf
			
			If InputPressed(KEY_EXIT) Then 
				gGameState = STATE_MENU
				SetMenu(gTitleMenu2)
				FlushKeys()
				FlushMouse()
			EndIf
	EndSelect
	
	UpdateConsole()
	
	glScissor 0, 0, sResX[sWindowRes], sResY[sWindowRes]
	
	If gTime = MilliSecs()/1000
		gTicks :+ 1
	Else
		gFps = gTicks
		gTicks = 0
		gTime = MilliSecs()/1000
		If gGameState = STATE_GAME And gPlayer <> Null Then
			If gPlayer.state <> 2 And gMapIntroTimer > 125 Then
				gTimeStat :+ 1
			EndIf
		EndIf
		ProfileUpdate()
	EndIf
	
	If InputPressed(KEY_MOUSELOCKTOGGLE) Then gMouseLock = Not gMouseLock
	If gMouseLock = True Then
		gMouseDX = MouseX() - 480
	Else
		gMouseDX = 0.0
	EndIf
	If Not AppSuspended() And gGameState = STATE_GAME And gMouseLock = True  Then MoveMouse(480, 360)
	GCCollect()
		
	Flip -1
End Function

Function DrawQuad(x1:Float, y1:Float, x2:Float, y2:Float, flipH:Int = False, flipV:Int = False)
	Local iFlipH = 1.0 - flipH
	Local iFlipV = 1.0 - flipV
	glBegin GL_QUADS
		glTexCoord2f flipH, iFlipV; glVertex2f x1, y2
		glTexCoord2f iFlipH, iFlipV; glVertex2f x2, y2
		glTexCoord2f iFlipH, flipV; glVertex2f x2, y1
		glTexCoord2f flipH, flipV; glVertex2f x1, y1
	glEnd
End Function

Function DrawSpinningMonster(x:Float, y:Float, orientation:Int, baseName:String, size:Float = 32.0)
	If orientation <> 3 Then
		glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, baseName + orientation +"_0")).id
		glBegin GL_QUADS
			glTexCoord2f 0.0, 0.0; glVertex2f x-size, y-size
			glTexCoord2f 0.0, 1.0; glVertex2f x-size, y+size
			glTexCoord2f 1.0, 1.0; glVertex2f x+size, y+size
			glTexCoord2f 1.0, 0.0; glVertex2f x+size, y-size
		glEnd
	Else
		glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, baseName + "1" +"_0")).id
		glBegin GL_QUADS
			glTexCoord2f 1.0, 0.0; glVertex2f x-size, y-size
			glTexCoord2f 1.0, 1.0; glVertex2f x-size, y+size
			glTexCoord2f 0.0, 1.0; glVertex2f x+size, y+size
			glTexCoord2f 0.0, 0.0; glVertex2f x+size, y-size
		glEnd
	EndIf
	glBindTexture GL_TEXTURE_2D, Null
End Function

Function DrawString(s:String, font:Int[], x:Float, y:Float, size:Int = 8)
	x :- size
	For Local i:Int = 1 To Len(s)
		Local m:String = Mid(s, i, 1)
		Local a:Byte = Asc(m) + 6
		
		glBindTexture GL_TEXTURE_2D, font[a]
		
		glBegin GL_QUADS
			glTexCoord2f 0.0, 1.0; glVertex2f x+(i*size), y+size
			glTexCoord2f 1.0, 1.0; glVertex2f x+(i*size)+size, y+size
			glTexCoord2f 1.0, 0.0; glVertex2f x+(i*size)+size, y
			glTexCoord2f 0.0, 0.0; glVertex2f x+(i*size), y
		glEnd
		
		glBindTexture GL_TEXTURE_2D, Null
		
	Next
End Function

Function AddParticle(x:Float, y:Float, z:Float, dx:Float, dy:Float, dz:Float, gravity:Float, life:Int, texture:TTexture)
	Local index:Int = -1
	For Local i:Int = 0 To Len(gParticles) - 1
		If gParticles[i].active = False Then
			index = i
			Exit
		EndIf
	Next
	If index > -1 Then
		gParticles[index] = New TParticle
		gParticles[index].x = x
		gParticles[index].y = y
		gParticles[index].z = z
		gParticles[index].r = 1.0
		gParticles[index].g = 1.0
		gParticles[index].b = 1.0
		gParticles[index].dx = dx
		gParticles[index].dy = dy
		gParticles[index].dz = dz
		gParticles[index].gravity = gravity
		gParticles[index].life = life
		gParticles[index].texture = texture
	EndIf
End Function

'===========================
'*LOADMAP
'============================
Function LoadMap()
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	glOrtho(0.0, 320, 240, 0.0, -1.0, 10.0)
	glViewport (0.0, 0.0, sResX[sWindowRes], sResY[sWindowRes])
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	glEnable GL_BLEND
	glEnable GL_TEXTURE_2D
	
	glClear GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT
	glLoadIdentity
	DrawString("LOADING MAP...", gFont, 4, 4, 16)
	
	Flip
	
	gTotalSecrets = 0
	gTotalSecretWalls = 0
	gTotalMonsters = 0
	gMapFlag = 0
	Local file:TStream = ReadFile("assets/maps/MAPINFO.txt")
	Local musName:String = ""
	While Not Eof(file)
		Local l:String = ReadLine(file)
		If l = "E"+gEpisodeNumber+"M"+gMapNumber Then
			musName = ReadLine(file)
			gMapName = ReadLine(file)
			gMapFlag = Byte(ReadLine(file))
		Else
			ReadLine(file)
			ReadLine(file)
			ReadLine(file)
		EndIf
	Wend
	CloseStream file 'COuld this be why the game slows down when switching episodes? Use CloseFile isntead
	
	If musName <> "" Then
		gMusic = LoadSound("assets/music/"+musName, SOUND_LOOP)
	EndIf

	file = ReadFile("assets/maps/E" + gEpisodeNumber + "M" + gMapNumber + ".ti")
	Local line:String = ""
	Local args:String[] = Null
	Local flag:Byte = 0
	ReadLine(file)
	Local wallCount:Int = Int(ReadLine(file))
	
	gMapWalls = New TWall[wallCount]
	
	gMonsters = CreateList()
	
	Local minX:Float = 10000.0
	Local maxX:Float = -10000.0
	Local maxZ:Float = -10000.0
	Local minZ:Float = 10000.0
	Local door:TDoor = Null
	gSecretWalls = CreateList()
	For Local i:Int = 0 To Len(gMapWalls) - 1
		line = ReadLine(file)
		args = line.Split(",")
		flag=Byte(args[4])
		If (Int(args[0])+8)/8 < minX Then minX = Int(args[0])/8
		If (Int(args[0])+8)/8 > maxX Then maxX = Int(args[0])/8
		If (Int(args[1])+8)/8 < minZ Then minZ = Int(args[1])/8
		If (Int(args[1])+8)/8 > maxZ Then maxZ = Int(args[1])/8
		If flag = 0 Then
			gMapWalls[i] = New TWall
			gMapWalls[i].x = (Int(args[0])+8) / 8.0
			gMapWalls[i].z = (Int(args[1])+8) / 8.0
			gMapWalls[i].y = 0.0
			gMapWalls[i].texture = TTexture(MapValueForKey(gTextures, args[3]))
			If Instr(args[3], "memewall") > 0 Then
				gMapWalls[i].texture = TTexture(MapValueForKey(gTextures, "memewall" + Rand(0, 7)))
			EndIf
			gMapWalls[i].id = Int(args[5])
		Else
			Select flag
				Case 1 'Horizontal Door
					door = New TDoor
					door.x = (Int(args[0])+8) / 8.0
					door.z = (Int(args[1])+8) / 8.0
					door.y = 0.0
					door.texture = TTexture(MapValueForKey(gTextures, args[3]))
					door.id = Byte(args[5])
					door.orientation = 0
					door.d = False
					door.orgX = door.x
					door.orgZ = door.z
					door.newX = door.x
					door.newZ = door.z
					door.newY = door.y
					door.orgY = door.y
					If args[3] = "spacedoor" Or args[3] = "spacedoor_dark" Then 
						door.orientation = 2
						door.speed = 0.1
					EndIf
					If door.id > 0 Then door.locked = True
					AddEntity(door)
				Case 2 'Vertical Door
					door = New TDoor
					door.x = (Int(args[0])+8) / 8.0
					door.z = (Int(args[1])+8) / 8.0
					door.y = 0.0
					door.texture = TTexture(MapValueForKey(gTextures, args[3]))
					door.id = Byte(args[5])
					door.orientation = 1
					door.orgX = door.x
					door.orgZ = door.z
					door.newX = door.x
					door.newZ = door.z
					door.newY = door.y
					door.orgY = door.y
					door.d = True
					If args[3] = "spacedoor" Or args[3] = "spacedoor_dark" Then 
						door.orientation = 2
						door.speed = 0.1
					EndIf
					door.locked = False
					If door.id > 0 Then door.locked = True
					AddEntity( door)
				Case 3 'Switch
					Local switch:TSwitch = New TSwitch
					switch.x = (Int(args[0])+8) / 8.0
					switch.z = (Int(args[1])+8) / 8.0
					switch.y = 0.0
					switch.texture = TTexture(MapValueForKey(gTextures, args[3]))
					switch.id = Byte(args[5])
					switch.state = False
					AddEntity( switch)
				Case 4 'Teleporter
					Local teleporter:TTeleporter = New TTeleporter
					teleporter.x = (Int(args[0]) + 8) / 8.0
					teleporter.z = (Int(args[1]) + 8) / 8.0
					teleporter.y = 0.0
					teleporter.id = Byte(args[5])
					teleporter.flag = flag
					AddEntity( teleporter)
				Case 5 'Secret Wall
					Local secretWall:TSecretWall = New TSecretWall
					secretWall = New TSecretWall
					secretWall.x = (Int(args[0])+8) / 8.0
					secretWall.z = (Int(args[1])+8) / 8.0
					secretWall.y = 0.0
					secretWall.texture = TTexture(MapValueForKey(gTextures, args[3]))
					secretWall.id = Int(args[5])
					secretWall.locked = False
					AddEntity( secretWall)
					gTotalSecrets :+ 1
					gTotalSecretWalls :+ 1
					ListAddLast gSecretWalls, secretWall
				Case 6 'Animated Wall
					gMapWalls[i] = New TWall
					gMapWalls[i].x = (Int(args[0])+8) / 8.0
					gMapWalls[i].z = (Int(args[1])+8) / 8.0
					gMapWalls[i].y = 0.0
					gMapWalls[i].texture = TTexture(MapValueForKey(gTextures, args[3]))
					gMapWalls[i].id = Int(args[5])
					If gMapWalls[i].id <> 0 Then gMapWalls[i].animSpeed = gMapWalls[i].id
					gMapWalls[i].animated = True
					gMapWalls[i].baseTexture = Replace(gMapWalls[i].texture.name, "_0", "_")
				Case 7 'Flat Wall
					Local fwall:TFlatWall = New TFlatWall
					fwall.x = (Int(args[0])+8) / 8.0
					fwall.z = (Int(args[1])+8) / 8.0
					fwall.y = 0.0
					fwall.texture = TTexture(MapValueForKey(gTextures, args[3]))
					fwall.id = Byte(args[5])
					fwall.orientation = fwall.id
					If Instr(args[3], "_notsolid") > 0 Then
						fwall.solid = False
					EndIf
					AddEntity( fwall)
				Case 8 'Locked Horizontal Door
					door = New TDoor
					door.x = (Int(args[0])+8) / 8.0
					door.z = (Int(args[1])+8) / 8.0
					door.y = 0.0
					door.texture = TTexture(MapValueForKey(gTextures, args[3]))
					door.id = Byte(args[5])
					door.key = door.id + 1
					door.orientation = 0
					door.orgX = door.x
					door.orgZ = door.z
						door.d = False
					door.newX = door.x
					door.newZ = door.z
					door.locked = True
					If args[3] = "spacedoor" Or args[3] = "spacedoor_dark" Then 
						door.orientation = 2
						door.speed = 0.1
					EndIf
					AddEntity(door)
				Case 9 'Locked Vertical Door
					door = New TDoor
					door.x = (Int(args[0])+8) / 8.0
					door.z = (Int(args[1])+8) / 8.0
					door.y = 0.0
					door.texture = TTexture(MapValueForKey(gTextures, args[3]))
					door.id = Byte(args[5])
					door.key = door.id + 1
					door.orientation = 1
					door.orgX = door.x
						door.d = True
					door.orgZ = door.z
					door.newX = door.x
					door.newZ = door.z
					door.locked = True
					If args[3] = "spacedoor" Or args[3] = "spacedoor_dark" Then 
						door.orientation = 2
						door.speed = 0.1
					EndIf
					AddEntity(door)
				Case 10 'Locked Secret Wall
					Local lsecretWall:TSecretWall = New TSecretWall
					lsecretWall = New TSecretWall
					lsecretWall.x = (Int(args[0])+8) / 8.0
					lsecretWall.z = (Int(args[1])+8) / 8.0
					lsecretWall.y = 0.0
					lsecretWall.texture = TTexture(MapValueForKey(gTextures, args[3]))
					lsecretWall.id = Int(args[5])
					lsecretWall.locked = True
					AddEntity( lsecretWall)
					ListAddLast gSecretWalls, lsecretWall
					gTotalSecretWalls :+ 1
				Case 11 'Trigger
					Local trigger:TTrigger = New TTrigger
					trigger.x = (Int(args[0])+8) / 8.0
					trigger.z = (Int(args[1])+8) / 8.0
					trigger.y = 0.0
					trigger.id = Int(args[5])
					If trigger.id = 255 Then gTotalSecrets :+ 1
					trigger.isExit = False
					AddEntity( trigger)
				Case 12 'Exit
					Local etrigger:TTrigger = New TTrigger
					etrigger.x = (Int(args[0])+8) / 8.0
					etrigger.z = (Int(args[1])+8) / 8.0
					etrigger.y = 0.0
					etrigger.id = Int(args[5])
					etrigger.isExit = True
					AddEntity( etrigger)
				Case 13 'Conveyor Belt
					Local con:TConveyor = New TConveyor
					con.x = (Int(args[0]) + 8) / 8.0
					con.z = (Int(args[1]) + 8) / 8.0
					con.id = Int(args[5])
					Select con.id
						Case 0
							con.direction = 0.0
						Case 1
							con.direction = 270.0
						Case 2
							con.direction = 180.0
						Case 3
							con.direction = 90.0
					EndSelect
					AddEntity(con)
			End Select
		EndIf
	Next
	Local mapWidth:Int = Abs(Int(maxX - minX)) + 2
	Local mapHeight:Int = Abs(Int(maxZ - minZ)) + 2
	flag = 0
	ReadLine(file)
	Local numSectors:Int = Int(ReadLine(file))
	
	gMapFloors = New TFloor[numSectors]
	For Local i:Int = 0 To numSectors - 1
		line = ReadLine(file)
		args = line.Split(",")
		gMapFloors[i] = New TFloor
		gMapFloors[i].x = (Int(args[0])+8) / 8.0
		gMapFloors[i].z = (Int(args[1])+8) / 8.0
		If Int(args[4]) = 0 Then
			gMapFloors[i].y = -1.0
		Else
			gMapFloors[i].y = +1.0
		EndIf
		gMapFloors[i].class = Int(args[4])
		gMapFloors[i].texture = TTexture(MapValueForKey(gTextures, args[5]))
	Next
	
	ReadLine(file)
	Local numEntities:Int = Int(ReadLine(file))
	Local monster:TMonster = Null
	For Local i:Int = 0 To numEntities - 1
		line = ReadLine(file)
		args = line.Split(",")
		flag = Byte(args[2])
		Select flag
			Case 0 'Player
				gPlayer.x = (Int(args[0]) + 8) / 8.0
				gPlayer.z = (Int(args[1]) + 8) / 8.0
				gPlayer.yaw = (Int(args[4]) * 45) + 90.0
			Case 1 'Prop
				Local tree:TProp = New TProp
				tree.x = (Int(args[0]) + 8) / 8.0
				tree.z = (Int(args[1]) + 8) / 8.0
				tree.radius = 0.75
				tree.texture = TTexture(MapValueForKey(gTextures, args[3]))
				tree.solid = True
				If Instr(args[3], "_notsolid") > 0 Then tree.solid = False
				AddEntity( tree)
			Case 2 'Item
				If args[3] = "medkit" Then
					Local item:TMedkit = New TMedkit
					item.x = (Int(args[0]) + 8) / 8.0
					item.z = (Int(args[1]) + 8) / 8.0
					item.radius = 0.5
					item.texture = TTexture(MapValueForKey(gTextures, "medkit"))
					AddEntity( item)
				ElseIf args[3] = "stimpack" Then
					Local item:TMedkit = New TMedkit
					item.x = (Int(args[0]) + 8) / 8.0
					item.z = (Int(args[1]) + 8) / 8.0
					item.radius = 0.5
					item.amount = 10
					item.texture = TTexture(MapValueForKey(gTextures, "stimpack"))
					AddEntity(item)
				ElseIf args[3] = "bluecard" Or args[3] = "browncard" Or args[3] = "graycard" Or args[3] = "yellowcard" Then
					Local keycard:TKeyCard = New TKeyCard
					keycard.x = (Int(args[0]) + 8) / 8.0
					keycard.z = (Int(args[1]) + 8) / 8.0
					keycard.radius = 0.5
					keycard.texture = TTexture(MapValueForKey(gTextures, args[3]))
					Select args[3]
						Case "bluecard"
							keycard.color = 0
						Case "browncard"
							keycard.color = 1
						Case "yellowcard"
							keycard.color = 2
						Case "graycard"
							keycard.color = 3
					EndSelect
					AddEntity( keycard)
				ElseIf args[3] = "cartonofeggs" Then
					Local eggammo:TAmmoPickup = New TAmmopickup
					eggammo.x = (Int(args[0]) + 8) / 8.0
					eggammo.z = (Int(args[1]) + 8) / 8.0
					eggammo.radius = 0.5
					eggammo.texture = TTexture(MapValueForKey(gTextures, args[3]))
					eggammo.amount = 7
					eggammo.weapon = gWeaponChicken
					eggammo.obituary = "GOT A CARTON OF EGGS"
					AddEntity( eggammo)
				ElseIf args[3] = "grenades" Then
					Local grenadeammo:TAmmoPickup = New TAmmoPickup
					grenadeammo.x = (Int(args[0]) + 8) / 8.0
					grenadeammo.z = (Int(args[1]) + 8) / 8.0
					grenadeammo.radius = 0.5
					grenadeammo.texture = TTexture(MapValueForKey(gTextures, args[3]))
					grenadeammo.amount = 3
					grenadeammo.weapon = gWeaponGrenade
					grenadeammo.obituary = "GOT SOME GRENADES"
					AddEntity(grenadeammo)
				ElseIf args[3] = "plasmavial" Then
					Local plasmaammo:TAmmoPickup = New TAmmoPickup
					plasmaammo.x = (Int(args[0]) + 8) / 8.0
					plasmaammo.z = (Int(args[1]) + 8) / 8.0
					plasmaammo.radius = 0.5
					plasmaammo.texture = TTexture(MapValueForKey(gTextures, args[3]))
					plasmaammo.amount = 50
					plasmaammo.weapon = gWeaponParusu
					plasmaammo.obituary = "GOT SOME VIALS OF PLASMA"
					AddEntity(plasmaammo)
				ElseIf args[3] = "boringarmor" Then
					Local armor:TArmorPickup = New TArmorPickup
					armor.x = (Int(args[0]) + 8) / 8.0
					armor.z = (Int(args[1]) + 8) / 8.0
					armor.r = 255
					armor.g = 128
					armor.b = 0
					armor.texture = TTexture(MapValueForKey(gTextures, args[3]))
					armor.armor = 50
					armor.armorType = ARMOR_BORING
					armor.obituary = "YOU GOT THE BORING ARMOR!"
					AddEntity(armor)
				ElseIf args[3] = "BULLETARMOR" Then
					Local armor:TArmorPickup = New TArmorPickup
					armor.x = (Int(args[0]) + 8) / 8.0
					armor.z = (Int(args[1]) + 8) / 8.0
					armor.r = 0
					armor.g = 128
					armor.b = 0
					armor.texture = TTexture(MapValueForKey(gTextures, args[3]))
					armor.armor = 60
					armor.armorType = ARMOR_BULLET
					armor.obituary = "YOU GOT THE BULLET ARMOR!"
					AddEntity(armor)
				ElseIf args[3] = "superarmor" Then
					Local armor:TArmorPickup = New TArmorPickup
					armor.x = (Int(args[0]) + 8) / 8.0
					armor.z = (Int(args[1]) + 8) / 8.0
					armor.r = 0
					armor.g = 128
					armor.b = 255
					armor.texture = TTexture(MapValueForKey(gTextures, args[3]))
					armor.armor = 100
					armor.armorType = ARMOR_SUPER
					armor.obituary = "YOU GOT THE SUPER ARMOR!"
					AddEntity(armor)
				EndIf
			Case 3 'Weapon Pickup
				Local pickup:TWeaponPickup = New TWeaponPickup
				pickup.x = (Int(args[0]) + 8) / 8.0
				pickup.z = (Int(args[1]) + 8) / 8.0
				pickup.radius = 0.5
				pickup.texture = TTexture(MapValueForKey(gTextures, args[3]))
				AddEntity( pickup)
			Case 4 'Wraith
				Local monster:TWraith = New TWraith
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 5 'Fire Wraith
				Local monster:TFireWraith = New TFireWraith
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 6 'Dummkopf
				Local monster:TDummkopf = New TDummkopf
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 7 'Cacowraith
				Local monster:TCacoWraith = New TCacoWraith
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 8 'Prisrak
				Local monster:TPrisrak = New TPrisrak
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 9 'Providence
				Local monster:TProvidence = New TProvidence
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 10 'Fundie
				Local monster:TFundie = New TFundie
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 11 'Banshee
				Local monster:TBanshee = New TBanshee
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 12 'Mutant Wraith
				Local monster:TMutant = New TMutant
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 13 'Mecha
				Local monster:TMecha = New TMecha
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 14 'Dummkopf (Disguised as a pawn)
				Local monster:TDummkopf = New TDummkopf
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				TDummkopf(monster).pawn = True
				monster.baseTextureName = "PAWN"
				monster.ambush = True
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
			Case 15 'The Tophat Demon
				Local monster:TDemon = New TDemon
				monster.x = (Int(args[0]) + 8) / 8.0
				monster.z = (Int(args[1]) + 8) / 8.0
				monster.angle = Int(args[4]) * 45
				ListAddLast(gMonsters, monster)
				gTotalMonsters :+ 1
		EndSelect
	Next
	CloseStream file
	Print "MAP LOADED: E"+gEpisodeNumber+"M"+gMapNumber
	Print "WIDTH "+mapWidth + " HEIGHT " + mapHeight
	
	'====================
	'QUADTREES
	'====================
	
	If gSectors <> Null Then
		For Local i:Int = 0 To 3
			gSectors[i].Clear()
		Next
	EndIf
	
	Local root:TSector = New TSector
	root.x = minX
	root.y = minZ
	root.width = mapWidth
	root.height = mapHeight
	'root.SubDivide()
	root.GetEntities()
	gSectors = New TSector[4]
	
	For Local i:Int = 0 To 3
		gSectors[i] = New TSector
		gSectors[i].width = mapWidth / 2.0
		gSectors[i].height = mapHeight / 2.0
		gSectors[i].parent = root
		ListAddLast root.children, gSectors[i]
	Next
	gSectors[0].x = minX
	gSectors[0].y = minZ
	gSectors[1].x = minX + mapWidth/2.0
	gSectors[1].y = minZ
	gSectors[2].x = minX + mapWidth/2.0
	gSectors[2].y = minZ + mapHeight/2.0
	gSectors[3].x = minX + 0.0
	gSectors[3].y = minZ + mapHeight/2.0
	If gBottomSectors <> Null Then ClearList gBottomSectors
	gBottomSectors = CreateList()
	For Local i:Int = 0 To 3
		gSectors[i].MakeVectors()
		gSectors[i].GetEntities()
		gSectors[i].SubDivide()
	Next
	
	Print "QUADTREE GENERATED"
	
	For Local ee:TEntity = EachIn gEntities
		ee.Init()
	Next
	
	'DETERMINE WALL NEIGHBORS AND BUILD MAP TEXTURE CHAIN
	ClearMap gMapWallGroups
	For Local w:TWall = EachIn gMapWalls
		w.Init()
		If w.texture.name = "invisible" Then Continue
		For Local w2:TWall = EachIn gMapWalls
			If w2.class = "wall" And w2.texture.name <> "invisible" Then
				If w2.x = w.x + 2.0 And w2.z = w.z Then
					w.rightOcc = True
				ElseIf w2.x = w.x - 2.0 And w2.z = w.z Then
					w.leftOcc = True
				EndIf
				If w2.z = w.z + 2.0 And w2.x = w.x Then
					w.bottomOcc = True
				ElseIf w2.z = w.z - 2.0 And w2.x = w.x Then
					w.topOcc = True
				EndIf
			EndIf
		Next
		If Not MapContains(gMapWallGroups, w.texture) Then
			Local wallGroup:TTextureChain = New TTextureChain
			MapInsert(gMapWallGroups, w.texture, wallGroup)
		EndIf
		ListAddLast TTextureChain(MapValueForKey(gMapWallGroups, w.texture)).walls, w
	Next
	For Local teet:TTexture = EachIn MapKeys(gMapWallGroups)
		Local walg:TTextureChain = TTextureChain(MapValueForKey(gMapWallGroups, teet))
		walg.MakeDisplayList(teet)
	Next
	
	'Build floors texture chains
	ClearMap gMapFloorGroups
	For Local i:Int = 0 To numSectors - 1
		gMapFloors[i].Init()
		If Not MapContains(gMapFloorGroups, gMapFloors[i].texture) Then
			Local floorGroup:TTextureChain = New TTextureChain 
			MapInsert(gMapFloorGroups, gMapFloors[i].texture, floorGroup)
		EndIf
		ListAddLast TTextureChain(MapValueForKey(gMapFloorGroups, gMapFloors[i].texture)).floors, gMapFloors[i]
	Next
	For Local teet:Object = EachIn MapKeys(gMapFloorGroups)
		Local flrg:TTextureChain = TTextureChain(MapValueForKey(gMapFloorGroups, teet))
		flrg.MakeDisplayList(TTexture(teet))
	Next
	
	If gMusic <> Null Then gMusicChannel = PlaySound(gMusic)
	
	GCCollect()
End Function

Function BuildLists()
	gDisplayLists = New Int[18] 'lists 16 and 17 are for walls and floors, respectively
	
	gDisplayLists[DL_WALLS] = glGenLists(1)
	gDisplayLists[DL_FLOORS] = glGenLists(1)
	
'	glDeleteLists(16, 2)
	
	gDisplayLists[0] = glGenLists(1)
	glNewList(gDisplayLists[0], GL_COMPILE)
	
	'---------------------
	'WALL DISPLAY LIST
	'---------------------
		
	glBegin GL_QUADS
		glColor3f 1.0, 1.0, 1.0
		'Front
		glTexCoord2f 1.0, 0.0; glVertex3f -1.0, +1.0, -1.0
		glTexCoord2f 0.0, 0.0; glVertex3f +1.0, +1.0, -1.0
		glTexCoord2f 0.0, 1.0; glVertex3f +1.0, -1.0, -1.0
		glTexCoord2f 1.0, 1.0; glVertex3f -1.0, -1.0, -1.0
		'Left
		glTexCoord2f 0.0, 1.0; glVertex3f -1.0, -1.0, -1.0
		glTexCoord2f 1.0, 1.0; glVertex3f -1.0, -1.0, +1.0
		glTexCoord2f 1.0, 0.0; glVertex3f -1.0, +1.0, +1.0
		glTexCoord2f 0.0, 0.0; glVertex3f -1.0, +1.0, -1.0
		glColor3f 0.8, 0.75, 0.8
		'Back
		glTexCoord2f 0.0, 1.0; glVertex3f -1.0, -1.0, +1.0
		glTexCoord2f 1.0, 1.0; glVertex3f +1.0, -1.0, +1.0
		glTexCoord2f 1.0, 0.0; glVertex3f +1.0, +1.0, +1.0
		glTexCoord2f 0.0, 0.0; glVertex3f -1.0, +1.0, +1.0
		'Right
		glTexCoord2f 1.0, 0.0; glVertex3f +1.0, +1.0, -1.0
		glTexCoord2f 0.0, 0.0; glVertex3f +1.0, +1.0, +1.0
		glTexCoord2f 0.0, 1.0; glVertex3f +1.0, -1.0, +1.0
		glTexCoord2f 1.0, 1.0; glVertex3f +1.0, -1.0, -1.0
	
	glEnd
	
	glEndList()
		
	'-----------------------
	'BILLBOARD DISPLAY LIST
	'-----------------------
	
	gDisplayLists[1] = glGenLists(1)
	glNewList(gDisplayLists[1], GL_COMPILE)
	
	glBegin GL_QUADS
		glColor3f 1.0, 1.0, 1.0
		glTexCoord2f 0.0, 1.0; glVertex3f -1.0, -1.0, 0.0
		glTexCoord2f 1.0, 1.0; glVertex3f +1.0, -1.0, 0.0
		glTexCoord2f 1.0, 0.0; glVertex3f +1.0, +1.0, 0.0
		glTexCoord2f 0.0, 0.0; glVertex3f -1.0, +1.0, 0.0
		
	glEnd
	
	
	glEndList()
	'-----------------------------
	'HORIZONTAL DOOR DISPLAY LIST
	'-----------------------------
	
	gDisplayLists[2] = glGenLists(1)
	glNewList(gDisplayLists[2], GL_COMPILE)
	glBegin GL_QUADS
		glColor3f 1.0, 1.0, 1.0
		glTexCoord2f 1.0, 1.0; glVertex3f -1.0, -1.0, 0.00
		glTexCoord2f 0.0, 1.0; glVertex3f +1.0, -1.0, 0.00
		glTexCoord2f 0.0, 0.0; glVertex3f +1.0, +1.0, 0.00
		glTexCoord2f 1.0, 0.0; glVertex3f -1.0, +1.0, 0.00
		
		glTexCoord2f 1.0, 0.0; glVertex3f -1.0, +1.0, 0.01
		glTexCoord2f 0.0, 0.0; glVertex3f +1.0, +1.0, 0.01
		glTexCoord2f 0.0, 1.0; glVertex3f +1.0, -1.0, 0.01
		glTexCoord2f 1.0, 1.0; glVertex3f -1.0, -1.0, 0.01
		
	glEnd
	
	glEndList()
	
	'---------------------------
	'VERTICAL DOOR DISPLAY LIST
	'---------------------------
	
	gDisplayLists[3] = glGenLists(1)
	glNewList(gDisplayLists[3], GL_COMPILE)
	glBegin GL_QUADS
		glColor3f 1.0, 1.0, 1.0
		glTexCoord2f 1.0, 1.0; glVertex3f 0.00, -1.0, -1.0
		glTexCoord2f 0.0, 1.0; glVertex3f 0.00, -1.0, +1.0
		glTexCoord2f 0.0, 0.0; glVertex3f 0.00, +1.0, +1.0
		glTexCoord2f 1.0, 0.0; glVertex3f 0.00, +1.0, -1.0
		
		glTexCoord2f 1.0, 0.0; glVertex3f 0.01, +1.0, -1.0
		glTexCoord2f 0.0, 0.0; glVertex3f 0.01, +1.0, +1.0
		glTexCoord2f 0.0, 1.0; glVertex3f 0.01, -1.0, +1.0
		glTexCoord2f 1.0, 1.0; glVertex3f 0.01, -1.0, -1.0
		
	glEnd
	
	glEndList()
	
	'-----------------------------
	'FLOOR/CEILING DISPLAY LIST
	'-----------------------------
	
	gDisplayLists[4] = glGenLists(1)
	glNewList(gDisplayLists[4], GL_COMPILE)
	glBegin GL_QUADS
	
		glTexCoord2f 0.0, 1.0; glVertex3f -1.0, 0.0, -1.0
		glTexCoord2f 1.0, 1.0; glVertex3f +1.0, 0.0, -1.0
		glTexCoord2f 1.0, 0.0; glVertex3f +1.0, 0.0, +1.0
		glTexCoord2f 0.0, 0.0; glVertex3f -1.0, 0.0, +1.0
	
	glEnd
	
	glEndList()
	
	'-----------------------
	'FLIPPED BILLBOARD DISPLAY LIST
	'-----------------------
	
	gDisplayLists[5] = glGenLists(1)
	glNewList(gDisplayLists[5], GL_COMPILE)
	
	glBegin GL_QUADS
		glColor3f 1.0, 1.0, 1.0
		glTexCoord2f 1.0, 1.0; glVertex3f -1.0, -1.0, 0.0
		glTexCoord2f 0.0, 1.0; glVertex3f +1.0, -1.0, 0.0
		glTexCoord2f 0.0, 0.0; glVertex3f +1.0, +1.0, 0.0
		glTexCoord2f 1.0, 0.0; glVertex3f -1.0, +1.0, 0.0
		
	glEnd
	
	glEndList()
	
End Function

'======================
'*INIT
'======================
Function InitGame()
	ProfileInit()

	If gEntities <> Null Then
		For Local i:Int = 0 To MAX_ENTITIES - 1
			Local ee:TEntity = gEntities[i]
			If TSickle(ee) <> Null Then 
				StopChannel(TSickle(ee).sound)
			EndIf
			If ee <> Null Then RemoveEntity(ee)
		Next
	EndIf
	For Local i:Int = 0 To 15
		If ChannelPlaying(gMonsterChannels[i]) Then StopChannel(gMonsterChannels[i])
	Next
	gEntities = New TEntity[MAX_ENTITIES]
	gParticles = New TParticle[MAX_PARTICLES]
	For Local i:Int = 0 To MAX_PARTICLES - 1
		gParticles[i] = New TParticle
		gParticles[i].active = False
	Next
	If gMusicChannel <> Null Then StopChannel gMusicChannel
	gGameInitialized = False
	gPlayer = New TPlayer
	LoadMap()
	Make3D()
	gMapIntroTimer = 0
	gMapIntroAlpha = 1.0
	gMessage = ""
	gMessageTimer = 0
	gWeapon = gWeaponSickle
	gWeaponOffsetY = 0.0
	gWeaponOffsetX = 0.0
	gWeaponBob = 0.0
	gWeaponChange = 0
	gNewWeapon = Null
	gSicklePresent = False
	gKeycards = New Int[4]
	gKeycards[0] = False
	gKeycards[1] = False
	gKeycards[2] = False
	gKeycards[3] = False
	gEnemyAIEnabled = True
	gGodMode = False
	gKillStat = 0
	gSecretStat = 0
	gTimeStat = 0
	If gMapNumber = 1 And gGameInitialized = False Then
		Local textStart:Byte = False
		Local textLength:Int = 0
		Local index:Int = 0
		Local file:TStream = ReadFile("assets/maps/EPISODEINFO.txt")
		While Not Eof(file)
			Local l:String = ReadLine(file)
			If textStart = True Then
				If l = ";" Then Exit
				gCutsceneText[index] = l
				Print index + ": " + gCutsceneText[index]
				index :+ 1
			EndIf
			If l = "E" + gEpisodeNumber Then
				textStart = True
				textLength = Int(ReadLine(file))
				gCutsceneText = New String[textLength]
			EndIf	
		Wend
		gCutsceneIndex = 0
		gCutsceneLine = 0
		gCutsceneDone = False
		gGameState = STATE_CUTSCENE
		If gMusicChannel <> Null Then StopChannel gMusicChannel
		gMusicChannel = PlaySound(gInterludeMusic)
		Return
	ElseIf gMapNumber = 9 Then
		Local textStart:Int = False
		Local textLength:Int = 0
		Local index:Int = 0
		Local file:TStream = ReadFile("assets/maps/EPISODEINFO.txt")
		While Not Eof(file)
			Local l:String = ReadLine(file)
			If textStart = True Then
				If l = ";" Then Exit
				gCutsceneText[index] = l
				Print index + ": " + gCutsceneText[index]
				index :+ 1
			EndIf
			If l = "E" + gEpisodeNumber Then
				textLength = Int(ReadLine(file))
				For Local i:Int = 0 To textLength - 1
					ReadLine(file)
				Next
				ReadLine(file)
				textLength = Int(ReadLine(file))
				textStart = True
				gCutsceneText = New String[textLength]
			EndIf	
		Wend
	EndIf
	gGameInitialized = True
End Function

Function RenderParticles()
	For Local i:Int = 0 To Len(gParticles) - 1
		If gParticles[i].active = True Then
			gParticles[i].Update()
			gParticles[i].Render()
		EndIf
	Next
End Function

Function ResetGame()
	gWeaponChicken.equipped = False
	gWeaponGrenade.equipped = False
	gWeaponDoubleGrenade.equipped = False
	gWeaponParusu.equipped = False
	gWeaponAirhorn.equipped = False
	gWeaponSign.equipped = False
	For Local i:Int = 0 To 3
		gAmmoTypes[i] = 0
	Next
	gKillStat = 0
	gSecretStat = 0
	gTimeStat = 0
End Function

Function AddEntity(e:TEntity)
	Local index:Int = -1
	For Local i:Int = 0 To MAX_ENTITIES - 1
		If gEntities[i] = Null Then
			index = i
			Exit
		EndIf
	Next
	If index > -1 Then
		gEntities[index] = e
		gEntities[index].index = index
	Else
		Print "MAXIMUM ENTITIES REACHED"
	EndIf	
End Function

Function RemoveEntity(e:TEntity)
	gEntities[e.index] = Null
	GCCollect()
End Function

Function FlashScreen(r:Byte, g:Byte, b:Byte, alpha:Float)
	gFlashR = r
	gFlashG = g
	gFlashB = b
	gFlashA = alpha
End Function

Function Make3D()
	glLoadIdentity()
	glMatrixMode GL_PROJECTION
	glLoadIdentity()
	glViewport 0.0, 0.0, sResX[sGameRes], sResY[sGameRes]
	'glOrtho 0.0, sResX[sGameRes], sResY[sGameRes], 0.0, -10.0, 10.0
	gluPerspective Float(sFov), 640.0 / 480.0, 0.1, 64.0
	glMatrixMode GL_MODELVIEW	
	glLoadIdentity	
	glEnable GL_DEPTH_TEST
	glEnable GL_TEXTURE_2D
	glEnable GL_BLEND
	glEnable GL_CULL_FACE
	glEnable GL_FOG
	glEnable GL_ALPHA_TEST
	glEnable GL_SCISSOR_TEST
	glDisable GL_NORMALIZE
	glDisable GL_DITHER
	glShadeModel GL_FLAT
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST)
	
	glLoadIdentity
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glAlphaFunc( GL_GREATER, 0.99 )
	glCullFace(GL_BACK)
	glClearColor 0.0, 0.0, 0.0, 1.0
	glFogi (GL_FOG_MODE, GL_LINEAR)
	glFogfv (GL_FOG_COLOR, [0.0, 0.0, 0.0, 1.0])
	glFogf (GL_FOG_START, 0.1)
	glFogf (GL_FOG_END, 32.0)
End Function

Function LoadTexture:Int(f:String)
	Local Texture:TPixmap = LoadPixmap(f)
	Local TextureImage:Int = GLTexFromPixmap(Texture, False)
	glBindTexture GL_TEXTURE_2D, TextureImage
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST)
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST)
	
	Return TextureImage
End Function

Function LoadTextureFromPixmap:Int(p:TPixmap)
	Local TextureImage:Int = GLTexFromPixmap(p, False)
	glBindTexture GL_TEXTURE_2D, TextureImage
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST)
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST)
	Return TextureImage
End Function

Function Distance3D:Float(x1:Float, y1:Float, z1:Float, x2:Float, y2:Float, z2:Float)
	Return Sqr((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) + (z1-z2)*(z1-z2))
End Function

Function Distance:Float(x1:Float, y1:Float, x2:Float, y2:Float)
	Return Sqr((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))
End Function

Function LoadTexture2(path:String, name:String)
	Local texture:TTexture = New TTexture
	Local tex:Int = LoadTexture(path)
	texture.id = tex
	texture.name = name
	MapInsert gTextures, name, texture
End Function

Function LoadAnimTexture(nf:String, frameWidth:Int, frameHeight:Int)
	Local pixmap:TPixmap = LoadPixmap(nf)
	For Local i:Int = 0 To (PixmapWidth(pixmap) / frameWidth) - 1
		Local p:TPixmap = pixmap.Window((i*frameWidth), 0, frameWidth, frameHeight)
		Local tex:Int = LoadTextureFromPixmap(p)
		Local texture:TTexture = New TTexture
		texture.id = tex
		texture.name = StripAll(nf)+"_" + i
		MapInsert gTextures, StripAll(nf)+"_" + i, texture
	Next 
	Print "ANIMATED TEXTURE LOADED: " + StripAll(nf)
End Function

Function GetCos:Float(angle:Float)
	If angle >= 360.0 Then angle :- 360.0
	If angle < 0.0 Then angle :+ 360.0
	Return Cos(Floor(angle))
End Function

Function GetSin:Float(angle:Float)
	If angle >= 360.0 Then angle :- 360.0
	If angle < 0.0 Then angle :+ 360.0
	Return Sin(Floor(angle))
End Function

Function Play2DSound(name:String, volume:Float = 1.0)
	SetChannelVolume(PlaySound(TSound(MapValueForKey(gSounds, name))), sSoundVolume * volume)
End Function

Function Play3DSound(name:String, x:Float, z:Float, volumeOffset:Float = 40.0, channel:TChannel = Null)
	Play3DSound2(TSound(MapValueForKey(gSounds, name)), x, z, volumeOffset, channel)
End Function

Function Play3DSound2(sound:TSound, x:Float, z:Float, volumeOffset:Float = 40.0, channel:TChannel = Null)
	Local volume:Float = sSoundVolume * Max(0.0, 1.0 - (Distance(x, z, gPlayer.x, gPlayer.z) / volumeOffset))
	If volume < 0.05 Then volume = 0.0
	SetChannelVolume(PlaySound(sound, channel), volume)
End Function

Function Begin2D()
	glMatrixMode(GL_PROJECTION)
	glPushMatrix()
	glLoadIdentity()
	glOrtho(0.0, 320, 240, 0.0, -1.0, 10.0)
	glMatrixMode(GL_MODELVIEW)
	glPushMatrix()
	glLoadIdentity()
	glEnable(GL_BLEND)
			
	glDisable GL_DEPTH_TEST
	glDisable GL_ALPHA_TEST
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glAlphaFunc( GL_GREATER, 0.99 )
End Function

Function End2D()
	glMatrixMode(GL_PROJECTION)
	glPopMatrix()
	glMatrixMode(GL_MODELVIEW)
	glPopMatrix()
			
	glEnable GL_DEPTH_TEST
	glEnable GL_ALPHA_TEST
End Function

Function MakeWindow()
	EndGraphics
	GLShareContexts()
	GLGraphics sResX[sWindowRes], sResY[sWindowRes], 0, 60
	Make3D()
End Function	

Function FitToScreen()
	glMatrixMode(GL_PROJECTION)
	glPushMatrix()
	glLoadIdentity()
	glDisable GL_BLEND
	glDisable GL_ALPHA_TEST
	glDisable GL_DEPTH_TEST
	glViewport 0.0, 0.0, sResX[sWindowRes], sResY[sWindowRes]
	glOrtho 0.0, sResX[sWindowRes], sResY[sWindowRes], 0.0, -1.0, 10.0
					
	glMatrixMode(GL_MODELVIEW)
	glPushMatrix()
	glLoadIdentity()
	
	glBindTexture GL_TEXTURE_2D, gRenderTarget
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, 0, 0, sResX[sGameRes], sResY[sGameRes], 0)				
	glColor4f 1.0, 1.0, 1.0, 1.0
	DrawQuad(0.0, 0.0, sResX[sWindowRes], sResY[sWindowRes], False, True)
					
	glPopMatrix()	
	glMatrixMode(GL_PROJECTION)
	glPopMatrix()
	'glMatrixMode(GL_MODELVIEW)
	
	'glEnable GL_BLEND
	glEnable GL_DEPTH_TEST
	glEnable GL_ALPHA_TEST
End Function

Function MonsterPlaySound(sound:TSound)
	If gAvailableMonsterChannel > -1 Then PlaySound(sound, gMonsterChannels[gAvailableMonsterChannel])
End Function

Function IsFacing(x:Float, z:Float, angle:Float, x1:Float, z1:Float, ofs:Float = 0.0)
	Local wd:TVector = MakeVector(GetCos(angle), GetSin(angle))
	Local dv:TVector = SubtractVector(MakeVector(x, z), MakeVector(x1, z1))
	Local dd:Float = DotVector(wd, dv)
	If dd < ofs Then Return True Else Return False
End Function

Function Cleanup()
	For Local i:Int = 0 To MAX_ENTITIES - 1
		gEntities[i] = Null
	Next
	If gMonsters <> Null Then
		ClearList gMonsters
	EndIf
	For Local i:Int = 0 To Len(gMapWalls) - 1
		gMapWalls[i] = Null
	Next
	For Local i:Int = 0 To Len(gMapFloors) - 1
		gMapFloors[i] = Null
	Next
	For Local i:Int = 0 To 15
		gMonsterChannels[i] = Null
	Next
	If gSectors <> Null Then
		For Local i:Int = 0 To 3
			gSectors[i].Clear()
		Next
	EndIf
	ClearMap gTextures
	ClearMap gSounds
	glDeleteLists(0, 200)
	GCCollect()
EndFunction