Type TTexture
	Field id:Int = 0
	Field name:String = ""
EndType

Type TEntity
	Field index:Int = 0
	Field id:Int = 0
	Field class:String = ""
	Field x:Float = 0.0
	Field y:Float = 0.0
	Field z:Float = 0.0
	Field dx:Float = 0.0
	Field dz:Float = 0.0
	Field yaw:Float = 0.0
	Field radius:Float = 1.0
	Field texture:TTexture = Null	
	Field planes:TPlane[]
	Method Init()
	End Method
	
	Method Update()	
	End Method
	
	Method Render()	
	End Method
EndType

Type TMonster Extends TEntity
	Field frame:Byte = 0
	Field anim:Byte = 0
	Field animation:Byte[]
	Field walkAnimation:Byte[]
	Field deathAnimation:Byte[]
	Field hurtFrame:Byte = 04
	Field animSpeed:Byte = 10
	Field health:Int = 100
	Field maxHealth:Int = 100
	Field target:TEntity
	Field speed:Float = 0.0
	'Field dx:Float = 0.0
	'Field dz:Float = 0.0
	Field contactDamage:Byte = 5
	Field angle:Float = 0.0
	Field spriteAngle:Int = 0
	Field seeSound:TSound = Null
	Field painSound:TSound = Null
	Field deathSound:TSound = Null
	Field baseTextureName:String = ""
	Field active:Byte = False
	Field hurtTimer:Byte = 0
	Field state:Byte = 0
	Field dist2p:Float = 0.0
	Field ddx:Float = 0.0
	Field ddz:Float = 0.0
	Field k:Float = 0.0
	Field a:Float = 0.0
	Field foundWall:Byte = False
	Field colX:Float = 0.0
	Field colZ:Float = 0.0
	Field painChance:Int = 3
	Field animationRepeat:Int = True
	Field knockback:Float = 0.0
	Field knockbackDirection:Float = 0.0
	Field cwmf:Byte = True
	Field cwiw:Byte = True
	Field makeNoise:Byte = True
	Field canConveyor:Byte = True
	
	Field a2p:Float = 0.0
	Field rayStart:TVector
	Field rayDir:TVector
	Field minD:Float = 0.0
	Field i:Int = 0
	Field e:TEntity
	Field dp:Float = 0.0
	Field l2:Float = 0.0
	Field v0p:Float = 0.0
	Field v1p:Float = 0.0
	Field rsp:Float = 0.0
	Field d0:Float = 0.0
	Field d1:Float = 0.0
	Field d2:Float = 0.0
	Field d3:Float = 0.0
	Field j:Int = 0
	Field axis:TVector
	Field buffer:Float = 0.0
	Field dv:TVector
	Field wd:TVector
	Field dd:Float = 0.0
	Field p:TProjectile
	Field walkTimer:Int = 0
	Field addAngle:Float = 0.0
	Field flipSprite:Byte = False
	Field ambush:Byte = False
	Field bleed:Byte = True
	Field buf:Int = 0
	Field ofs:Float = 1.1

	Method New()
		class = "monster"
		'channel = AllocChannel()
		target = gPlayer
	End Method
	Method Init()
		
	End Method
	Method Activate()
		If foundWall = False Then
			active = True
			angle = ATan2(target.z-z, target.x-x)
			If angle >= 360.0 Then angle :- 360.0
			If angle < 0.0 Then angle :+ 360.0
			gPlayer.hearRange = 30.0
			If makeNoise = True Then MonsterPlaySound(seeSound)
		EndIf
	End Method
	Method Revive()
		i = 0
		For e = EachIn gMonsters
			If e.class = "monster" And Distance(e.x, e.z, x, z) - radius - e.radius <= 1.0 And e <> Self Then
				i = 1
				Exit
			EndIf
		Next
		If i = 0 Then
			class = "monster"
			health = maxHealth
			animation = walkAnimation
			frame = 0
			anim = 0
			state = 0
			animSpeed = 10
			target = gPlayer
			active = True
			If makeNoise = True Then MonsterPlaySound(seeSound)
		EndIf
	End Method
	Method Die()
		
		class = "corpse"
		dx = 0.0
		dz = 0.0
		animation = deathAnimation
		animationRepeat = True
		animSpeed = 10
		frame = 0
		anim = 0
		state = 2
		If makeNoise = True Then MonsterPlaySound(deathSound)
		gKillStat :+ 1
		OnDie()
		
	End Method
	Method Update()
		dist2p = Distance(target.x, target.z, x, z) 
		If dist2p < 48.0 And gEnemyAIEnabled = True Then	
			yaw = -ATan2((gPlayer.z - gPlayer.camSin) - z, (gPlayer.x - gPlayer.camCos) - x) + 90.0
			If gPlayer.state = 2 And state <> 2 Then 
				class = "corpse"
				dx = 0.0
				dz = 0.0
				animation = deathAnimation
				animSpeed = 10
				frame = 0
				anim = 0
				state = 2
			EndIf
			If angle >= 360.0 Then angle :- 360.0
			If angle < 0.0 Then angle :+ 360.0
			
			spriteAngle = GetSpriteAngle(x, z, angle)
			If state <> 2 Then
				flipSprite = False
				If spriteAngle = 3 Then 
					spriteAngle = 1
					flipSprite = True
				EndIf
			EndIf
			buf :+ 1
			If buf > 2 Then buf = 0
			If state <> 2 Then
				If buf = 1 Then
					'================================
					'     *PLAYER DETECTION
					'================================
										
					a2p = Int(ATan2(gPlayer.z-z, gPlayer.x-x))
					rayStart = MakeVector(x, z)
					rayDir = MakeVector(GetCos(a2p), GetSin(a2p))
					foundWall = True
					minD = 1000000.0
										
					Local potSectors:TList = GetSectorsOnRay(rayStart, rayDir, dist2p)
										
					For Local sc:TSector = EachIn potSectors
						sc.marked = True
						If CountList(sc.entities) > 0 Then
							'd0= Distance(x,z,sc.x+sc.width/2,sc.y+sc.height/2)
							'If d0 <= dist2p+1.0 Then
								
								For e = EachIn sc.entities
									If Distance(e.x, e.z, x, z) <= dist2p Then
										If (e.class <> "wall:prop" Or active = True) And Instr(e.texture.name, "invisible") = 0 Then
											If TDoor(e) <> Null Then
												If TDoor(e).s = False Then Continue
											EndIf
											If TSecretWall(e) <> Null Then
												If TSecretWall(e).activated = True Then Continue
											EndIf
											
											If e.planes[0] <> Null Then
												dp= 0.0
												l2= 0.0
												v0p= 0.0
												v1p= 0.0
												rsp= 0.0
												For j = 0 To 3
													dp = DotVector(rayDir, e.planes[j].n)
													If dp <> 0.0 Then
														l2 = DotVector(e.planes[j].n, SubtractVector(e.planes[j].v0, rayStart))/dp
														If l2 > 0.0 Then
															axis = MakeVector(e.planes[j].n.y, -e.planes[j].n.x)
															v0p = DotVector(axis, e.planes[j].v0)
															v1p = DotVector(axis, e.planes[j].v1) 
															rsp = DotVector(axis, AddVector(rayStart, MakeVector(rayDir.x*l2, rayDir.y*l2)))
															If rsp >= Min(v0p,v1p) And rsp <= Max(v0p,v1p) Then
																foundWall = True
																If l2 < minD Then 
																	minD = l2
																EndIf
															EndIf
														EndIf
													EndIf
												Next
											EndIf
										EndIf
									EndIf
								Next
							'EndIf
							If dist2p > minD Then
								foundWall = True
								Exit
							EndIf
						EndIf
					Next
					If dist2p < minD Then
						foundWall = False
					EndIf
					
				Else
					foundWall = True
				EndIf
			EndIf
			If active = False Then
				wd= MakeVector(GetCos(angle), GetSin(angle))
				dv= SubtractVector(MakeVector(x, z), MakeVector(target.x, target.z))
				dd= DotVector(wd, dv)
				If dd < 0.0 And dist2p < 48.0 Then
					Activate()
				ElseIf dist2p < gPlayer.hearRange And ambush = False Then
					Activate()
				EndIf
			EndIf
			If active = True Then
				target = gPlayer
				i = 0
				
				For e = EachIn gEntities
					If x+radius>e.x-e.radius And x-radius<e.x+e.radius And z+radius>e.z-e.radius And z-radius<e.z+e.radius Then
						If e.class = "projectile" Then
							p = TProjectile(e)
							If p.friendly And state <> 2 Then
								p.OnDestroy()
								If TGrenade(p) <> Null Then Explode(x, p.y, z, 4.0, 20, p.direction)
								If TSickle(p) = Null Then
									RemoveEntity(e)
								Else
									Play3DSound("cut", x, z, 40.0)
								EndIf
								Hurt(p.damage)
								knockback = p.knockback
								knockbackDirection = p.direction
								Exit
							EndIf
						ElseIf e.class = "conveyor" And i = 0 And canConveyor = True Then
							knockback = TConveyor(e).speed
							knockbackDirection = TConveyor(e).direction
							i = 1
						EndIf
					EndIf
				Next
				
				Update2()
				knockback :* 0.9
				If Abs(knockback) < 0.025 Then knockback = 0.0
				Select state
					Case 0 'Default
						If knockback <> 0.0 Then
							dx = GetCos(knockbackDirection) * knockback
							dz = GetSin(knockbackDirection) * knockback
						EndIf
						TryMove(x, z, dx, dz, radius, Self, cwmf, cwiw)
						x :+ dx
						z :+ dz
						anim :+ 1
						If anim > animSpeed Then
							anim = 0
							frame :+ 1
							If frame > Len(animation) - 1 
								If animationRepeat = True Then 
									frame = 0
								Else
									frame = Len(animation) - 1
								EndIf
							EndIf
						EndIf
						texture = TTexture(MapValueForKey(gTextures, baseTextureName + spriteAngle + "_" + animation[frame]))
						If health <= 0 Then
							Die()
						EndIf
					Case 1 'Hurt
						texture = TTexture(MapValueForKey(gTextures, baseTextureName + spriteAngle + "_" + hurtFrame))
						hurtTimer :- 1
						If hurtTimer <= 0 Then
							state = 0
						EndIf
						If knockback <> 0.0 Then
							dx = GetCos(knockbackDirection) * knockback
							dz = GetSin(knockbackDirection) * knockback
						EndIf
						TryMove(x, z, dx, dz, radius, Self)
						x :+ dx
						z :+ dz
						If health <= 0 Then
							Die()
						EndIf
					Case 2 'Dead
						anim :+ 1
						If anim > animSpeed Then
							anim = 0
							frame :+ 1
							frame = Min(frame, Len(animation) - 1)
							texture = TTexture(MapValueForKey(gTextures, baseTextureName + "0_" + animation[frame]))
						EndIf
				EndSelect
			Else
				anim :+ 1
				If anim > animSpeed Then
					anim = 0
					frame :+ 1
					If frame > Len(animation) - 1 
						frame = 0
					EndIf
					texture = TTexture(MapValueForKey(gTextures, baseTextureName + spriteAngle + "_" + animation[frame]))
				EndIf
				For e = EachIn gEntities
					If x+radius>e.x-e.radius And x-radius<e.x+e.radius And z+radius>e.z-e.radius And z-radius<e.z+e.radius Then
						If e.class = "projectile" Then
							p = TProjectile(e)
							If p.friendly And state <> 2 Then
								p.OnDestroy()
								If TSickle(p) = Null Then RemoveEntity(e)
								Hurt(p.damage)
								If active = False Then 
									Activate()
								EndIf
								Exit
							EndIf
						EndIf
					EndIf
				Next
			EndIf
		Else
			
		EndIf
		a2p = Null
		rayStart = Null
		rayDir = Null
		minD= Null
		i= Null
		e= Null
		dp= Null
		l2= Null
		v0p= Null
		v1p= Null
		rsp= Null
		d0= Null
		d1= Null
		d2= Null
		d3= Null
		j= Null
		axis= Null
		buffer= Null
		dv= Null
		wd= Null
		dd= Null
		p= Null
	End Method
	Method Hurt(damage:Int, usePainChance:Byte = True)
		health :- damage
		If bleed = True Then
			For i = 0 To 2 
				AddParticle(x, y, z, (RndFloat()*0.5)-0.25, 0.2, (RndFloat()*0.5)-0.25, 0.025, 20, TTexture(MapValueForKey(gTextures, "particles_1")))
			Next
		EndIf
		If (Floor(Rnd(0,painChance)) = 1 Or usePainChance = False) And painChance <> -1 Then
			hurtTimer = 15
			frame = 0
			anim = 0
			If makeNoise = True And state <> 1 Then MonsterPlaySound(painSound)
			state = 1
		EndIf
	End Method
	Method Update2()
		
	End Method
	Method OnDie()
		
	End Method
	Method A_WraithChase()
		If state <> 2 And state <> 1 And buf = 1 Then
			If dist2p > 0.9 Then		
				If foundWall = False Then
					angle = ATan2(target.z-z, target.x-x)
					If CheckWall(x+GetCos(angle + addAngle) * speed, z+GetSin(angle + addAngle) * speed, radius, Self, True, False) = True And walkTimer >= 150 Then
						walkTimer = 50
					EndIf	
					walkTimer :+ 1	
					If walkTimer = 16 Then
						addAngle = Int(Rand(-1, 1)) * 45
					ElseIf walkTimer = 33 Then
						addAngle = Int(Rand(-1, 1)) * 45
					ElseIf walkTimer >= 50 Then
						walkTimer = 0
						addAngle = 0.0
					EndIf
				Else
					addAngle = 0
					If CheckWall(x+GetCos(angle + addAngle) * speed, z+GetSin(angle + addAngle) * speed, radius, Self, True, False) = True Then
						Local ds0:Float = Distance(target.x, target.z, x+GetCos(angle+addAngle+90)*speed, z+GetSin(angle+addAngle+90)*speed)
						Local ds1:Float = Distance(target.x, target.z, x+GetCos(angle+addAngle-90)*speed, z+GetSin(angle+addAngle-90)*speed)
						If ds0 <= ds1 Then
							angle :+ 45
						Else
							angle :- 45
						EndIf
					EndIf
				EndIf
				'Radius not speed
				For Local m:TMonster = EachIn gMonsters
					If x+(GetCos(angle)*radius)+radius>=m.x-m.radius And x+(GetCos(angle)*radius)-radius<=m.x+m.radius And z+(GetSin(angle)*radius)+radius>=m.z-m.radius And z+(GetSin(angle)*radius)-radius<=m.z+m.radius And m <> Self And m.state <> 2 Then
						addAngle = 180
						walkTimer = 0
					EndIf
				Next
				angle :+ addAngle
				If angle >= 360.0 Then angle :- 360.0
				If angle < 0.0 Then angle :+ 360.0
				dx = GetCos(angle) * speed
				dz = GetSin(angle) * speed
			Else
				angle = ATan2(target.z-z, target.x-x)
				dx = 0.0
				dz = 0.0
			EndIf
		EndIf
	End Method
	Method Render()
		If texture <> Null Then glBindTexture GL_TEXTURE_2D, texture.id
		glMatrixMode(GL_MODELVIEW)
		glPushMatrix()
		glTranslatef x, y, z
		glRotatef yaw, 0, 1, 0
		
		If flipSprite = False Then
			glCallList(gDisplayLists[1])
		Else
			glCallList(gDisplayLists[5])
		EndIf
		
		glLoadIdentity()
		glMatrixMode(GL_MODELVIEW)
		glPopMatrix()
		glBindTexture GL_TEXTURE_2D, Null
	End Method
EndType

Function GetSpriteAngle:Int (x:Float, z:Float, angle:Float)
	If angle >= 360.0 Then angle :- 360.0
	If angle < 0.0 Then angle :+ 360.0
	Local ddx:Float = x-gPlayer.x
	Local ddz:Float = z-gPlayer.z
	Local k:Float = 1.0/Sqr(ddx*ddx + ddz*ddz)
	ddx :* k
	ddz :* k
	Local a:Float = 0.0
	If ddz < 0.0 Then
		a = 360.0 - ACos(ddx)
	Else
		a = ACos(ddx)
	EndIf
	a :- angle + 135.0
	If a >= 360.0 Then a :- 360.0
	If a < 0.0 Then a :+ 360.0
	Local spriteAngle:Int = Floor(a)*4/360
	If spriteAngle < 0 Then spriteAngle = 0
	If spriteAngle > 3 Then spriteAngle = 3
	Return spriteAngle
End Function

Type TWeapon 
	Field ammoType:Int = 0 
	Field frame:Byte = 0 
	Field maxframes:Byte = 3
	Field anim:Byte = 0 
	Field equipped:Byte = False 
	Field TextureName:String = "" 
	Field obituary:String = ""
	Field cooldown:Int = 0
	Field maxcooldown:Int = 50
	Field knockback:Float = 0.0
	Field infiniteAmmo:Byte = False
	Field cameraShake:Int = 0
End Type

Type TPlayer Extends TEntity
	Field forward:Float = 0.0
	Field strafe:Float = 0.0
	Field maxSpeed:Float = .15
	Field dx:Float = 0.0
	Field dz:Float = 0.0
	Field camCos:Float = 0.0
	Field camSin:Float = 0.0
	Field noclip:Byte = False
	Field canShoot:Byte = True
	Field hearRange:Float = 2.0
	Field health:Int = 100
	Field state:Byte = 0
	Field velocity:Float = 0.0
	
	Field armorType:Byte = 0
	Field armor:Int = 0
	
	Field e:TEntity
	Field d:TDoor
	Field s:TSwitch
	Field i:Int = 0
	
	Field egg:TEgg
	Field grenade:TGrenade
	Field sickle:TSickle
	Field fireball:TFireball
	Field rx:Float = 0.0
	Field rz:Float = 0.0
	Field p:TProp
	
	Field wd:TVector
	Field dv:TVector
	Field dd:Float = 0.0
	Method New()
		class = "player"
		radius = 0.5
		If gGameDifficulty >= DIFFICULTY_EASY Then health = 200
	End Method	
	
	Method Update()
		If state = 0 Then
			e = Null
			d = Null
			s = Null
			
			yaw :+ gMouseDX * sMouseSensitivity
			yaw :+ (InputDown(KEY_TURN_RIGHT) - InputDown(KEY_TURN_LEFT)) * sMouseSensitivity * 25.0
			
			If yaw > 360.0 Then yaw :- 360.0
			If yaw < 0.0 Then yaw :+ 360.0
			If gGodMode = True Then health = 100
			If (InputDown(KEY_SHOOT) Or InputDown(KEY_ALTFIRE)) And canShoot = True And (gAmmoTypes[gWeapon.ammoType] > 0 Or gWeapon.infiniteAmmo = True) And gWeaponChange = 0 Then
				If gWeapon = gWeaponSickle And gSicklePresent = True Then
					
				Else
					canShoot = False
					gWeapon.cooldown = gWeapon.maxcooldown
					gWeapon.frame = 0
					hearRange = 30.0
					forward :- gWeapon.knockback
					If armorType <> ARMOR_BULLET Then
						If gWeapon.infiniteAmmo = False Then gAmmoTypes[gWeapon.ammoType] :- 1
						If gWeapon = gWeaponDoubleGrenade Then gAmmoTypes[AMMO_GRENADE] :- 1
					EndIf
					gCameraShakeTimer = gWeapon.cameraShake
				EndIf
				Select gWeapon
					Case gWeaponChicken
						egg = New TEgg
						egg.x = x
						egg.y = y - 0.125
						egg.z = z
						egg.direction = yaw - 90.0
						AddEntity(egg)
						If InputDown(KEY_ALTFIRE) And gAmmoTypes[AMMO_EGG] >= 3 Then
							For i = 0 To 1
								egg = New TEgg
								egg.x = x
								egg.y = y - 0.125
								egg.z = z
								egg.direction = yaw - 105.0 + (i * 30.0)
								AddEntity(egg)
							Next
							If armorType <> ARMOR_BULLET Then gAmmoTypes[AMMO_EGG] :- 2
							gWeaponChicken.maxcooldown = 15
						EndIf
						If InputDown(KEY_SHOOT) And Not InputDown(KEY_ALTFIRE) Then gWeaponChicken.maxcooldown = 10
						gWeapon.cooldown = gWeapon.maxcooldown

						Play2DSound("chickengun")
					Case gWeaponGrenade
						grenade = New TGrenade
						grenade.x = x
						grenade.y = y - 0.125
						grenade.z = z
						grenade.velocity = 0.05
						grenade.direction = yaw - 90.0
						AddEntity(grenade)
						Play2DSound("grenadelaunch")
					Case gWeaponDoubleGrenade
						For i = 0 To 1
							grenade = New TGrenade
							grenade.x = x
							grenade.y = y - 0.125
							grenade.z = z
							grenade.velocity = 0.05
							grenade.direction = yaw - 95.0 + (10.0 * i)
							AddEntity(grenade)
						Next
						Play2DSound("doublegrenadelaunch")
					Case gWeaponParusu
						fireball = New TFireball
						fireball.x = x+GetCos(yaw - 90.0)*0.1
						fireball.y = -0.25
						fireball.z = z+GetSin(yaw - 90.0)*0.1
						fireball.direction = yaw - 90.0
						fireball.friendly = True
						fireball.texture.name = "PLASMABALL_"
						fireball.damage = 2
						fireball.knockback = 0.5
						AddEntity(fireball)
						Play2DSound("parusu")
					Case gWeaponSign
						For Local m:TMonster = EachIn gMonsters
							If Distance(x, z, m.x, m.z) < 3.0 And m.state <> 2 Then
								If IsFacing(x, z, yaw - 90.0, m.x, m.z, -0.6) Then
									m.Hurt(25, False)
									Play2DSound("hit")
									Exit
								EndIf
							EndIf
						Next
						For Local e:TEntity = EachIn gEntities
							If TChicken(e) <> Null Then
								Local chk:TChicken = TChicken(e)
								If Distance(x, z, chk.x, chk.z) < 3.0 And chk.state = 0 Then
									If IsFacing(x, z, yaw - 90.0, chk.x, chk.z, -0.6) Then
										chk.health = 0
										Play2DSound("hit")
										Exit
									EndIf
								EndIf
							EndIf
						Next
						Play2DSound("swish")
					Case gWeaponAirhorn
						hearRange = 90.0
						Play2DSound("airhorn")
				EndSelect
			EndIf
			If hearRange > 2.0 Then hearRange :- 1.0
			
			If canShoot = False Then
				gWeapon.anim :+ 1
				If gWeapon.anim > 3 Then
					gWeapon.frame :+ 1
					If gWeapon.frame > gWeapon.maxframes - 1 Then
						gWeapon.frame = gWeapon.maxframes - 1
					EndIf
					gWeapon.anim = 0
				EndIf
				If gWeapon = gWeaponSickle And gWeapon.frame = 2 And gWeapon.anim = 0 Then
					sickle = New TSickle
					sickle.x = x
					sickle.y = y
					sickle.z = z
					sickle.direction = yaw - 90.0
					sickle.speed = 0.45 + maxSpeed
					AddEntity(sickle)
					gSicklePresent = True
				EndIf
				gWeapon.cooldown :- 1
				If gWeapon.cooldown <= 0 Then
					If gWeapon = gWeaponSickle And gSicklePresent = True Then
					
					Else 
						canShoot = True
						gWeapon.frame = 0
					EndIf
				EndIf
			EndIf
			
			If InputPressed(KEY_USE) Then
				For e = EachIn gEntities
					If Distance(e.x, e.z, x, z) < 4.0 Then
						If IsFacing(x, z, yaw - 90.0, e.x, e.z, -0.8) Then
							If e.class <> "trigger" Then
								If Instr(e.class,"door") > 0 Then
									d = TDoor(e)
									d.Toggle()
								ElseIf Instr(e.class,"switch") > 0 Then
									s = TSwitch(e)
									s.Toggle()
								ElseIf Instr(e.class,"secretwall") > 0 Then
									Local w:TSecretWall = TSecretWall(e)
									If w.locked = False And w.activated = False Then 
										w.activated = True
										gSecretStat :+ 1
										Play3DSound("secretwall", e.x, e.z)
									EndIf
								ElseIf e.texture <> Null Then
									If e.texture.name = "NECKBEARD" Then
										gMessageTimer = 100
										gMessage = "M'LADY!"
									ElseIf e.texture.name = "CALEB" Then
										gMessageTimer = 150
										gMessage = "IN MARANA DOMUS-BHAAVA CRUNATUS!!"
									ElseIf e.texture.name = "yungvenuz" Then
										gMessageTimer = 100
										gMessage = "DANG, WHAT'S HIS PROBLEM?"
									ElseIf e.texture.name = "geoffrey_animated_10_0" Or e.texture.name = "geoffrey_animated_10_1" Then
										gMessageTimer = 100
										gMessage = "WHO'S THIS DOUCHEBAG?"
									EndIf
								EndIf	
							EndIf
						EndIf
						
					EndIf
				Next
			EndIf
			
			If InputDown(KEY_RUN) Then
				maxSpeed = .20
			Else
				maxSpeed = .15
			EndIf
			
			If armorType = ARMOR_SUPER Then
				maxSpeed = .3
			EndIf
			
			If InputDown(KEY_FORWARD) Then
				forward :+ 0.04
			ElseIf InputDown(KEY_BACKWARD) Then
				forward :- 0.04
			Else
				forward :* 0.9
				If Abs(forward) < 0.005 Then forward = 0.0
			EndIf
			forward = Min(Max(forward, -maxSpeed), maxSpeed)
			
			If InputDown(KEY_STRAFERIGHT) Then
				strafe :+ 0.04
			ElseIf InputDown(KEY_STRAFELEFT) Then
				strafe :- 0.04
			Else
				strafe :* 0.9
				If Abs(strafe) < 0.005 Then strafe = 0.0
			EndIf
			strafe = Min(Max(strafe, -maxSpeed), maxSpeed)
			
			If gWeaponChange = 0 And (forward <> 0.0 Or strafe <> 0.0) Then
				gWeaponBob :+ 1 + 1.5*(InputDown(KEY_RUN) Or armorType = ARMOR_SUPER)
			EndIf
			
			camCos = GetCos(yaw - 90.0)
			camSin = GetSin(yaw - 90.0)
			
			dx = GetCos(yaw - 90.0) * forward
			dz = GetSin(yaw - 90.0) * forward
			dx :+ GetCos(yaw) * strafe
			dz :+ GetSin(yaw) * strafe
			
			If dx = 0.0 And dz = 0.0 Then
				gIdleTicks :+ 1
				If gIdleTicks = 600 Then
					gJokeIndex = Rand(0, Len(gJokes) - 1)
					gMessageTimer = 250
					gMessage = gJokes[gJokeIndex][0]
				EndIf
				If gIdleTicks = 900 Then
					gMessageTimer = 250
					gMessage = gJokes[gJokeIndex][1]
				EndIf
				If gIdleTicks = 1200 Then
					gMessageTimer = 100
					gMessage = "HEH..."
				EndIf
			Else
				gIdleTicks = 0
			EndIf
			
			i = 0
			For e = EachIn gEntities
				If Instr(e.class,"prop") > 0 Then
					p = TProp(e)
					If p.solid = False Then
						If x+dx+radius > p.x-p.radius And x+dx-radius < p.x+p.radius And z+dz+radius > p.z-p.radius And z+dz-radius < p.z+p.radius Then
							p.OnPickup()
						EndIf
					EndIf
				ElseIf x+radius>=e.x-e.radius And x-radius<=e.x+e.radius And z+radius>=e.z-e.radius And z-radius<=e.z+e.radius Then
					If e.class = "projectile" Then
						If TProjectile(e).friendly = False Then
							If armorType = ARMOR_BORING Then
								health :- Ceil(TProjectile(e).damage / 2.0)
							ElseIf armorType = ARMOR_SUPER Then
								health :- Ceil(TProjectile(e).damage / 4.0)
							Else
								health :- TProjectile(e).damage
							EndIf
							armor :- TProjectile(e).damage / 2
							FlashScreen(255, 0, 0, 0.5)
							TProjectile(e).OnDestroy()
							RemoveEntity(e)
						EndIf
					ElseIf e.class = "conveyor" And i = 0 Then
						dx :+ GetCos(TConveyor(e).direction) * (TConveyor(e).speed * 2.0)
						dz :+ GetSin(TConveyor(e).direction) * (TConveyor(e).speed * 2.0)
						i = 1
					EndIf
				EndIf
			Next
			For Local m:TMonster = EachIn gMonsters
				If x+radius>=m.x-m.radius And x-radius<=m.x+m.radius And z+radius>=m.z-m.radius And z-radius<=m.z+m.radius Then
					If gEnemyAIEnabled = True And m.state <> 2 Then
						If armorType = ARMOR_BORING Then
							health :- Ceil(m.contactDamage / 2.0)
						ElseIf armorType = ARMOR_SUPER Then
							health :- Ceil(m.contactDamage / 4.0)
						Else
							health :- m.contactDamage
						EndIf
						armor :- m.contactDamage / 2
						FlashScreen(255, 0, 0, 0.5)
					EndIf
				EndIf
			Next
			If health < 0 Then health = 0
			If health > 255 Then health = 255
			If health <= 0 Then 
				state = 1
				velocity = 0.05
			EndIf
			If armor <= 0 Then
				armorType = ARMOR_NONE
				armor = 0
			EndIf
			If (dx <> 0.0 Or dz <> 0.0) And noclip = False Then
				TryMove(x, z, dx, dz, radius, Self, False)
			EndIf 
			
			z :+ dz
			x :+ dx
		ElseIf state = 1 Then
			yaw :+ 8.0
			yaw = yaw Mod 360.0
			camCos = GetCos(yaw - 90.0)
			camSin = GetSin(yaw - 90.0)
			FlashScreen(255, 0, 0, 0.5)
			velocity :- 0.0025
			y :+ velocity
			If y < -0.75 Then y = -0.75
			gWeapon.frame = 0
			If InputPressed(KEY_CONFIRM) Or InputPressed(KEY_USE) And y <= -0.75 Then
				gResetFlag = True
			EndIf	
		ElseIf state = 2 Then
			If InputPressed(KEY_CONFIRM) Then
				If gMapNumber = 9 And gMapFlag = 1 Then
					gCutScnFlag = True
				Else
					gGameState = STATE_GAME
					InitGame()
				EndIf
			EndIf
		EndIf
	End Method
EndType

Function TryMove(x:Float, z:Float, dx:Float Var, dz:Float Var, radius:Float, ent:TEntity, includeMonsters:Byte = True, includeInvisibleWalls:Byte = True)
	Local pos:TVector = Null
	'For Local i:Int = 0 To Len(gSectors) - 1
		'If x+dx-radius > gSectors[i].x And x+dx+radius < gSectors[i].x + gSectors[i].width And z+dz-radius > gSectors[i].y And z+dz+radius < gSectors[i].y + gSectors[i].height Then
			Local c:TSector = FindCurrentSector(x, z, dx, dz, radius, gSectors[0].parent)
			If c <> Null Then
				''''''''
				For Local ww:TEntity = EachIn c.entities
					If ww.class = "wall:prop" Then
						If TProp(ww).solid = True Then
							If x+dx+radius > ww.x-ww.radius And x+dx-radius < ww.x+ww.radius And z+radius > ww.z-ww.radius And z-radius < ww.z+ww.radius Then
								dx = 0
							EndIf
							If x+radius > ww.x-ww.radius And x-radius < ww.x+ww.radius And z+dz+radius > ww.z-ww.radius And z+dz-radius < ww.z+ww.radius Then
								dz = 0
							EndIf
						EndIf
					ElseIf ww.class = "wall:door" Then
						If TDoor(ww).s = True Then
							If x+dx+radius > ww.x-1.0 And x+dx-radius < ww.x+1.0 And z+radius > ww.z-1.0 And z-radius < ww.z+1.0 Then
								dx = 0
							EndIf
							If x+radius > ww.x-1.0 And x-radius < ww.x+1.0 And z+dz+radius > ww.z-1.0 And z+dz-radius < ww.z+1.0 Then
								dz = 0
							EndIf
						EndIf
					ElseIf ww.class = "secretwall" Then
						If TSecretWall(ww).activated = False Then
							If x+dx+radius > ww.x-1.0 And x+dx-radius < ww.x+1.0 And z+radius > ww.z-1.0 And z-radius < ww.z+1.0 Then
								dx = 0
							EndIf
							If x+radius > ww.x-1.0 And x-radius < ww.x+1.0 And z+dz+radius > ww.z-1.0 And z+dz-radius < ww.z+1.0 Then
								dz = 0
							EndIf
						EndIf
					ElseIf includeInvisibleWalls = True Or ww.texture.name <> "invisible" Then
						If TFlatWall(ww) <> Null Then
							If TFlatWall(ww).solid = False Then Continue
						EndIf
						If x+dx+radius > ww.x-1.0 And x+dx-radius < ww.x+1.0 And z+radius > ww.z-1.0 And z-radius < ww.z+1.0 Then
							dx = 0
						EndIf
						If x+radius > ww.x-1.0 And x-radius < ww.x+1.0 And z+dz+radius > ww.z-1.0 And z+dz-radius < ww.z+1.0 Then
							dz = 0
						EndIf
					EndIf
				Next 
				''''''''
				
			EndIf
		'Else
		'	Continue
		'EndIf
	'Next
	For Local e:TEntity = EachIn gSecretWalls
		If e.texture.name <> "invisible" Then
			If x+dx+radius > e.x-1.0 And x+dx-radius < e.x+1.0 And z+radius > e.z-1.0 And z-radius < e.z+1.0 Then
				dx = 0
			EndIf
			If x+radius > e.x-1.0 And x-radius < e.x+1.0 And z+dz+radius > e.z-1.0 And z+dz-radius < e.z+1.0 Then
				dz = 0
			EndIf
		EndIf
	Next
	If includeMonsters = True Then
		For Local m:TMonster = EachIn gMonsters
			If m <> ent And m.state <> 2 Then
				If x+dx+radius > m.x-1.0 And x+dx-radius < m.x+1.0 And z+radius > m.z-1.0 And z-radius < m.z+1.0 Then
					dx = 0
				EndIf
				If x+radius > m.x-1.0 And x-radius < m.x+1.0 And z+dz+radius > m.z-1.0 And z+dz-radius < m.z+1.0 Then
					dz = 0
				EndIf	
			EndIf
		Next
	EndIf
End Function

Function CheckWall:Int(x:Float, z:Float, radius:Float, ent:TEntity, includeInvisibleWalls:Byte = False, checkEnemies:Byte = False)
	Local dx:Float = 0.0
	Local dz:Float = 0.0
	'For Local i:Int = 0 To Len(gSectors) - 1
		'If x+dx-radius > gSectors[i].x And x+dx+radius < gSectors[i].x + gSectors[i].width And z+dz-radius > gSectors[i].y And z+dz+radius < gSectors[i].y + gSectors[i].height Then
			Local c:TSector = FindCurrentSector(x, z, dx, dz, radius, gSectors[0].parent)
			If c <> Null Then
				''''''''
				For Local ww:TEntity = EachIn c.entities
					If ww.class = "wall:prop" Then
						If TProp(ww).solid = True Then
							If x+radius > ww.x-ww.radius And x-radius < ww.x+ww.radius And z+radius > ww.z-ww.radius And z-radius < ww.z+ww.radius Then
								Return True
							EndIf
						EndIf
					ElseIf ww.class = "wall:door" Then
						If TDoor(ww).s = True Then
							If x+radius > ww.x-1.0 And x-radius < ww.x+1.0 And z+radius > ww.z-1.0 And z-radius < ww.z+1.0 Then
								Return True
							EndIf
						EndIf
					ElseIf ww.class = "secretwall" Then
						If TSecretWall(ww).activated = False Then
							If x+radius > ww.x-1.0 And x-radius < ww.x+1.0 And z+radius > ww.z-1.0 And z-radius < ww.z+1.0 Then
								Return True
							EndIf
						EndIf
					ElseIf includeInvisibleWalls = True Or ww.texture.name <> "invisible" Then
						If TFlatWall(ww) <> Null Then
							If TFlatWall(ww).solid = False Then Continue
						EndIf
						If x+radius > ww.x-1.0 And x-radius < ww.x+1.0 And z+radius > ww.z-1.0 And z-radius < ww.z+1.0 Then
							Return True
						EndIf
					EndIf
				Next 
				''''''''
				'Exit
			EndIf
		'Else
		'	Continue
		'EndIf
	'Next

	For Local e:TEntity = EachIn gSecretWalls
		If x+dx+radius > e.x-1.0 And x+dx-radius < e.x+1.0 And z+dz+radius > e.z-1.0 And z+dz-radius < e.z+1.0 And e.texture.name <> "invisible" Then
			Return True
		EndIf
	Next
	If checkEnemies = True Then
		For Local m:TMonster = EachIn gMonsters
			If m <> ent And m.state <> 2 Then
				If x+dx+radius > m.x-1.0 And x+dx-radius < m.x+1.0 And z+dz+radius > m.z-1.0 And z+dz-radius < m.z+1.0 Then
					Return True
				EndIf
			EndIf
		Next
	EndIf
	Return False
End Function

Type TTeleporter Extends TEntity
	Field ready:Byte = True
	Field cooldown:Int = 0
	Field partner:TTeleporter = Null
	Field flag:Byte = 0
	
	Field t:TTeleporter
	Field e:TEntity
	Method New()
		class = "teleporter"
		radius = 1.0
	End Method
	Method Init()
		For e = EachIn gEntities
			t = TTeleporter(e)
			If e.id = id And e <> Self And t <> Null Then
				If t.flag = 4 Then 
					partner = t
				EndIf
			EndIf
		Next
	End Method
	Method Update()
		If Distance(x, z, gPlayer.x, gPlayer.z) - radius - gPlayer.radius <= 0.0 And ready = True And partner <> Null Then
			partner.ready = False
			partner.cooldown = 50
			FlashScreen 255, 0, 255, 1.0
			For Local e:TEntity = EachIn gEntities
				If Distance(e.x, e.z, partner.x, partner.z) < 2.0 And e.class = "monster" Then
					Local m:TMonster = TMonster(e)
					m.health = 0
				EndIf
			Next
			gPlayer.x = partner.x
			gPlayer.z = partner.z
			SetChannelVolume(PlaySound(TSound(MapValueForKey(gSounds, "teleport"))),sSoundVolume)
		EndIf
		If ready = False Then
			cooldown :- 1
			If cooldown <= 0 Then ready = True
		EndIf
	End Method
	Method Render()
		'You don't!
	End Method
EndType

Type TWall Extends TEntity
	Field displayList:Byte = 0
	Field static:Byte = False
	Field orientation:Byte = 0
	Field animated:Byte = False
	Field animSpeed:Int = 5
	Field anim:Int = 0
	Field frame:Byte = 0
	Field baseTexture:String = ""
	Field solid:Byte = True
	Field leftOcc:Byte = False 'Is grid space to left occupied?
	Field rightOcc:Byte = False
	Field topOcc:Byte = False
	Field bottomOcc:Byte = False
	
	Field nmArg:String[]
	Method New()
		class = "wall"
		planes = New TPlane[4]
	End Method
	
	Method Init()
		If Instr(texture.name, "_animated") > 0 And animated = False Then
			animated = True
			nmArg = texture.name.Split("_")
			animSpeed = Int(nmArg[2])
			baseTexture = nmArg[0] + "_" + nmArg[1] + "_" + nmArg[2]
		EndIf
		planes[0]    = MakePlane(MakeVector(x-1.0,z-1.0), MakeVector(x+1.0,z-1.0))
		planes[1]    = MakePlane(MakeVector(x-1.0,z+1.0), MakeVector(x+1.0,z+1.0))
		planes[2]    = MakePlane(MakeVector(x+1.0,z-1.0), MakeVector(x+1.0,z+1.0))
		planes[3]    = MakePlane(MakeVector(x-1.0,z-1.0), MakeVector(x-1.0,z+1.0))
	End Method
		
	Method Update()
		If animated = True Then
			anim :+ 1
			If anim > animSpeed Then
				anim = 0
				If TTexture(MapValueForKey(gTextures, baseTexture + "_" + (frame + 1))) = Null Then
					frame = 0
				Else
					frame :+ 1
				EndIf
			EndIf
			texture = TTexture(MapValueForKey(gTextures, baseTexture + "_" + frame))
		EndIf
	End Method
	Method Render()
		If texture.name <> "invisible" Then
			If (Distance(x, z, gPlayer.x, gPlayer.z) < 48.0 And (IsFacing(gPlayer.x, gPlayer.z, gPlayer.yaw - 90.0, x, z, 1.1) Or Abs(gMouseDx) > 15)) Or gGameInitialized = False Then
				glBindTexture GL_TEXTURE_2D, texture.id
				glMatrixMode(GL_MODELVIEW)
				glPushMatrix()
				glTranslatef x, y, z
				
				glCallList(gDisplayLists[DL_BLOCK])
				
				glLoadIdentity()
				glMatrixMode(GL_MODELVIEW)
				glPopMatrix()
				glBindTexture GL_TEXTURE_2D, Null
			EndIf
		EndIf
	End Method
	Method Render2()
		If bottomOcc = False Or topOcc = False Or leftOcc = False Or rightOcc = False Then
			glColor3f 1.0, 1.0, 1.0
			glBegin GL_QUADS
			If topOcc = False Then 'Front
				glTexCoord2f 1.0, 0.0; glVertex3f x-1.0, y+1.0, z-1.0
				glTexCoord2f 0.0, 0.0; glVertex3f x+1.0, y+1.0, z-1.0
				glTexCoord2f 0.0, 1.0; glVertex3f x+1.0, y-1.0, z-1.0
				glTexCoord2f 1.0, 1.0; glVertex3f x-1.0, y-1.0, z-1.0
			EndIf
			If leftOcc  = False Then 'Left
				glTexCoord2f 0.0, 1.0; glVertex3f x-1.0, y-1.0, z-1.0
				glTexCoord2f 1.0, 1.0; glVertex3f x-1.0, y-1.0, z+1.0
				glTexCoord2f 1.0, 0.0; glVertex3f x-1.0, y+1.0, z+1.0
				glTexCoord2f 0.0, 0.0; glVertex3f x-1.0, y+1.0, z-1.0
			EndIf
			glColor3f 0.8, 0.75, 0.8
			If bottomOcc = False Then 'Back
				glTexCoord2f 0.0, 1.0; glVertex3f x-1.0, y-1.0, z+1.0
				glTexCoord2f 1.0, 1.0; glVertex3f x+1.0, y-1.0, z+1.0
				glTexCoord2f 1.0, 0.0; glVertex3f x+1.0, y+1.0,z +1.0
				glTexCoord2f 0.0, 0.0; glVertex3f x-1.0, y+1.0, z+1.0
			EndIf
			If rightOcc  = False Then 'Right
				glTexCoord2f 1.0, 0.0; glVertex3f x+1.0, y+1.0, z-1.0
				glTexCoord2f 0.0, 0.0; glVertex3f x+1.0, y+1.0,z +1.0
				glTexCoord2f 0.0, 1.0; glVertex3f x+1.0, y-1.0, z+1.0
				glTexCoord2f 1.0, 1.0; glVertex3f x+1.0, y-1.0, z-1.0
			EndIf
			glEnd
		EndIf
	End Method
EndType

Type TFloor
	Field x:Float = 0.0
	Field y:Float = 0.0
	Field z:Float = 0.0
	Field class:Int = 0
	Field texture:TTexture
	Field animated:Int = False
	Field baseName:String = ""
	Field anim:Int = 0
	Field animSpeed:Int = 3
	Field frame:Int = 0
	
	Field nmArg:String[]
	Method Init()
		If Instr(texture.name, "_animated") > 0 Then
			animated = True
			nmArg = texture.name.Split("_")
			animSpeed = Int(nmArg[2])
			baseName = nmArg[0] + "_" + nmArg[1] + "_" + nmArg[2]
		EndIf
	End Method
	Method Update()
		If texture <> Null Then
			If animated = True  Then
				anim :+ 1
				If anim > animSpeed Then
					anim = 0
					If TTexture(MapValueForKey(gTextures, baseName + "_" + (frame + 1))) <> Null Then
						frame :+ 1
					Else
						frame = 0
					EndIf
					texture = TTexture(MapValueForKey(gTextures, baseName + "_" + frame))
				EndIf
			EndIf
		EndIf
	End Method
	Method Render()
		If (Distance(x, z, gPlayer.x, gPlayer.z) < 48.0 And ((IsFacing(gPlayer.x, gPlayer.z, gPlayer.yaw - 90.0, x, z, 1.15) Or Abs(gMouseDx) > 15) Or gPlayer.state = 2)) Or gGameInitialized = False Then
				glBindTexture GL_TEXTURE_2D, texture.id
				glMatrixMode(GL_MODELVIEW)
				glPushMatrix()
				glTranslatef x, y, z
				If class = 0 Then glRotatef 180.0, 1, 0, 0
				glCallList(gDisplayLists[4])
				
				glLoadIdentity()
				glMatrixMode(GL_MODELVIEW)
				glPopMatrix()
				glBindTexture GL_TEXTURE_2D, Null
			EndIf
	End Method
	Method Render2()
		If class = 0 Then 
			glBegin GL_QUADS
			glTexCoord2f 0.0, 1.0; glVertex3f x-1.0, y, z-1.0
			glTexCoord2f 0.0, 0.0; glVertex3f x-1.0, y, z+1.0
			glTexCoord2f 1.0, 0.0; glVertex3f x+1.0, y, z+1.0
			glTexCoord2f 1.0, 1.0; glVertex3f x+1.0, y, z-1.0
			glEnd
		Else
			glBegin GL_QUADS
			glTexCoord2f 0.0, 1.0; glVertex3f x-1.0, y, z-1.0
			glTexCoord2f 1.0, 1.0; glVertex3f x+1.0, y, z-1.0
			glTexCoord2f 1.0, 0.0; glVertex3f x+1.0, y, z+1.0
			glTexCoord2f 0.0, 0.0; glVertex3f x-1.0, y, z+1.0
			glEnd
		EndIf
	End Method
End Type

Type TTextureChain 'Level geometry with the same texture is grouped together to minimize texture switching
	Field floors:TList = CreateList()
	Field walls:TList = CreateList()
	Field displayList:Int = -1
	Method MakeDisplayList(tex:TTexture)
		displayList = glGenLists(1)
		glNewList displayList, GL_COMPILE
		glBindTexture GL_TEXTURE_2D, tex.id
		For Local fl:TFloor = EachIn floors
			If fl.animated = False Then fl.Render2()
		Next
		For Local wl:TWall = EachIn walls
			If wl.animated = False Then wl.Render2()
		Next
		glEndList
	End Method
	Method Render()
		glCallList displayList
		For Local fl:TFloor = EachIn floors
			If fl.animated = True Then 
				fl.Update()
				fl.Render()
			EndIf
		Next
		For Local wl:TWall = EachIn walls
			If wl.animated = True Then
				wl.Update()
				wl.Render()
			EndIf
		Next
	End Method
EndType

Type TProjectile Extends TEntity
	Field friendly:Int = True
	Field direction:Float = 0.0
	Field speed:Float = 0.05
	Field dx:Float = 0.0
	Field dz:Float = 0.0
	Field frame:Byte = 0
	Field damage:Byte = 2
	Field knockback:Float = 0.0
	Field anim:Int = 0
	Field animSpeed:Int = 2
	Field maxFrames:Int = 3
	Field owner:TEntity = Null
	Field flipSprite:Byte = False
	Field static:Byte = False
	
	Field e:TEntity = Null
	Field m:TMonster = Null
	Method New()
		class = "projectile"
	End Method
	Method Update()
		
	End Method
	Method A_Projectile()
		yaw = -ATan2((gPlayer.z - gPlayer.camSin) - z, (gPlayer.x - gPlayer.camCos) - x) + 90.0
		If direction >= 360.0 Then direction :- 360.0
		If direction < 0.0 Then direction :+ 360.0
		If Not static Then
			If gGameDifficulty = DIFFICULTY_EASIEST And friendly = False Then
				dx = GetCos(direction) * speed * 0.5
				dz = GetSin(direction) * speed * 0.5
			ElseIf gGameDifficulty = DIFFICULTY_EASY And friendly = False Then
				dx = GetCos(direction) * speed * 0.75
				dz = GetSin(direction) * speed * 0.75
			Else
				dx = GetCos(direction) * speed
				dz = GetSin(direction) * speed
			EndIf
		EndIf
		x :+ dx
		z :+ dz
		anim :+ 1
		If anim > animSpeed Then
			anim = 0
			frame :+ 1
			If frame > maxFrames - 1 Then frame = 0
		EndIf
		If CheckWall(x, z, radius, Self) = True Then
			OnDestroy()
			RemoveEntity(Self)
		EndIf
	End Method
	Method OnDestroy()
		
	End Method
	Method Render()
		glBindTexture GL_TEXTURE_2D, TTexture(MapValueForKey(gTextures, texture.name + frame)).id
		glMatrixMode(GL_MODELVIEW)
		glPushMatrix()
		glTranslatef x, y, z
		glRotatef yaw, 0, 1, 0
		
		If flipSprite = False Then
			glCallList(gDisplayLists[1])
		Else
			glCallList(gDisplayLists[5])
		EndIf
		
		glLoadIdentity()
		glMatrixMode(GL_MODELVIEW)
		glPopMatrix()
		glBindTexture GL_TEXTURE_2D, Null
	End Method
EndType

Type TProp Extends TEntity
	Field solid:Int = True
	Field animated:Byte = False
	Field anim:Byte = 0
	Field animSpeed:Byte = 5
	Field frame:Byte = 0
	Field baseTextureName:String = ""
	Field loopAnim:Byte = True
	Field flipTexture:Byte = False
	
	Field nmArg:String[]
	Method New()
		class = "wall:prop"
		planes = New TPlane[4]
	EndMethod
	Method Update()
		If Distance(x, z, gPlayer.x, gPlayer.z) < 48.0 Then
			If planes[0] = Null Then
				planes[0]    = MakePlane(MakeVector(x-radius,z-radius), MakeVector(x+radius,z-radius))
				planes[1]    = MakePlane(MakeVector(x-radius,z+radius), MakeVector(x+radius,z+radius))
				planes[2]    = MakePlane(MakeVector(x+radius,z-radius), MakeVector(x+radius,z+radius))
				planes[3]    = MakePlane(MakeVector(x-radius,z-radius), MakeVector(x-radius,z+radius))
			EndIf
			yaw = -ATan2((-gCameraZ - gPlayer.camSin) - z, (-gCameraX - gPlayer.camCos) - x) + 90.0
			If Instr(texture.name, "_animated") > 0 And animated = False Then
				animated = True
				nmArg = texture.name.Split("_")
				animSpeed = Int(nmArg[2])
				baseTextureName = nmArg[0] + "_" + nmArg[1] + "_" + nmArg[2]
				loopAnim = True
			EndIf
			If animated = True Then
				anim :+ 1
				If anim > animSpeed Then
					anim = 0
					If TTexture(MapValueForKey(gTextures, baseTextureName + "_" + (frame + 1))) <> Null Then
						frame :+ 1
					ElseIf loopAnim = True Then
						frame = 0
					EndIf
				EndIf
				texture = TTexture(MapValueForKey(gTextures, baseTextureName + "_" + frame))
			EndIf
		EndIf
	End Method
	Method Render()
		If Distance(x, z, gPlayer.x, gPlayer.z) < 48.0 Then
			glBindTexture GL_TEXTURE_2D, texture.id
			glMatrixMode(GL_MODELVIEW)
			glPushMatrix()
			glTranslatef x, y, z
			glRotatef yaw, 0, 1, 0
			
			If flipTexture = False Then
				glCallList(gDisplayLists[1])
			Else
				glCallList(gDisplayLists[5])
			EndIf
			
			glLoadIdentity()
			glMatrixMode(GL_MODELVIEW)
			glPopMatrix()
			glBindTexture GL_TEXTURE_2D, Null
		EndIf
	End Method
	Method OnPickup()
		'RemoveEntity( Self)
	End Method
EndType

Type TParticle Extends TEntity
	Field r:Float
	Field g:Float
	Field b:Float
	Field gravity:Float = 0.0
	Field dx:Float = 0.0
	Field dy:Float = 0.0
	Field dz:Float = 0.0
	Field life:Int = 0
	Field active:Int = True
	Method New()
		class = "particle"
	End Method
	Method Update()
		life :- 1
		If life <= 0 Then active = False
		yaw = -ATan2((gPlayer.z - gPlayer.camSin) - z, (gPlayer.x - gPlayer.camCos) - x) + 90.0
		dy :- gravity
		x :+ dx
		z :+ dz
		y :+ dy
	End Method
	Method Render()
		glBindTexture GL_TEXTURE_2D, texture.id
		glMatrixMode(GL_MODELVIEW)
		glPushMatrix()
		glTranslatef x, y, z
		glRotatef yaw, 0, 1, 0
		glScalef 0.2, 0.2, 0.2
		
		glColor3f r, g, b
		glCallList(gDisplayLists[1])
		glColor3f 1.0, 1.0, 1.0
		
		glLoadIdentity()
		glMatrixMode(GL_MODELVIEW)
		glPopMatrix()
		glBindTexture GL_TEXTURE_2D, Null
	End Method
End Type